
// *****************
// *** EEPROM    ***
// *** Programme ***
// *****************



function EEPROM_Read(EE_Adresse : Byte) : Byte;
var
  EE_Daten : Byte;
begin

  EEARL:=EE_Adresse;
  EEARH:=0;

ASM;

EEPROM_M1:
  ; Wait for completion of previous write
  sbic EECR,EEPE
  rjmp EEPROM_M1

  ; Start eeprom read by writing EERE
  sbi EECR,EERE

ENDASM;

  EE_Daten:=EEDR;

  Result:=EE_Daten;

end  EEPROM_Read;



procedure EEPROM_Write(EE_Adresse, EE_Daten : Byte);
begin


ASM;

EEPROM_M2:
  ; Wait for completion of previous write
  sbic EECR,EEPE
  rjmp EEPROM_M2

ENDASM;

  EEARL:=EE_Adresse;
  EEARH:=0;

  EEDR:=EE_Daten;

ASM;

  ; Write logical one to EEMPE
  sbi EECR,EEMPE
  ; Start eeprom write by setting EEPE
  sbi EECR,EEPE

ENDASM;


end  EEPROM_Write;




