; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: PS2KBD.PAS
 
.nolist
.INCLUDE "m328Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x4800 ; WORD
.equ        UBRR_VAL  =  0x10 ; BYTE
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
.equ        CHAR_NULL  =  0x00 ; CHAR
.equ        CHAR_FC  =  0xFC ; CHAR
.equ        CHAR_FD  =  0xFD ; CHAR
.equ        CHAR_FE  =  0xFE ; CHAR
.equ        CHAR_FF  =  0xFF ; CHAR
.equ        NO_LED_STATE  =  0x00 ; BYTE
.equ        LEDSCROLL  =  0x01 ; BYTE
.equ        LEDNUM  =  0x02 ; BYTE
.equ        LEDCAPS  =  0x04 ; BYTE
.equ        KEYSTAT_BYTE1  =  0x01 ; BYTE
.equ        KEYSTAT_E0  =  0x02 ; BYTE
.equ        KEYSTAT_F0  =  0x03 ; BYTE
.equ        NO_SHIFTSTATE  =  0x00 ; BYTE
.equ        SHSHIFT  =  0x20 ; BYTE
.equ        SHCTRL  =  0x10 ; BYTE
.equ        SHALT  =  0x08 ; BYTE
.equ        SHCAPS  =  0x04 ; BYTE
.equ        SHNUM  =  0x02 ; BYTE
.equ        SHSCROLL  =  0x01 ; BYTE
.equ        KBDNUM  =  0x77 ; BYTE
.equ        KBDCAPS  =  0x58 ; BYTE
.equ        KBDSCROLL  =  0x7E ; BYTE
.equ        KBDALT  =  0x11 ; BYTE
.equ        KBDCTRL  =  0x14 ; BYTE
.equ        KBDLSHIFT  =  0x12 ; BYTE
.equ        KBDRSHIFT  =  0x59 ; BYTE
.equ        KBDENTER  =  0x5A ; BYTE
.equ        KBDSPACE  =  0x29 ; BYTE
.equ        KBDBS  =  0x66 ; BYTE
.equ        KBDTAB  =  0x0D ; BYTE
.equ        KBDESC  =  0x76 ; BYTE
.equ        KBDF1  =  0x05 ; BYTE
.equ        KBDF2  =  0x06 ; BYTE
.equ        KBDF3  =  0x04 ; BYTE
.equ        KBDF4  =  0x0C ; BYTE
.equ        KBDF5  =  0x03 ; BYTE
.equ        KBDF6  =  0x0B ; BYTE
.equ        KBDF7  =  0x83 ; BYTE
.equ        KBDF8  =  0x0A ; BYTE
.equ        KBDF9  =  0x01 ; BYTE
.equ        KBDF10  =  0x09 ; BYTE
.equ        KBDF11  =  0x78 ; BYTE
.equ        KBDF12  =  0x07 ; BYTE
.equ        KBDRGUI  =  0x27 ; BYTE
.equ        KBDLGUI  =  0x1F ; BYTE
.equ        KBDAPPS  =  0x2F ; BYTE
.equ        KBDEND  =  0x69 ; BYTE
.equ        KBDHOME  =  0x6C ; BYTE
.equ        KBDUP  =  0x75 ; BYTE
.equ        KBDDN  =  0x72 ; BYTE
.equ        KBDLEFT  =  0x6B ; BYTE
.equ        KBDRIGHT  =  0x74 ; BYTE
.equ        KBDPGUP  =  0x7D ; BYTE
.equ        KBDPGDN  =  0x7A ; BYTE
.equ        KBDINSERT  =  0x70 ; BYTE
.equ        KBDDELETE  =  0x71 ; BYTE
.equ        KBDPRINT  =  0x12 ; BYTE
.equ        KBDPAUSE  =  0xE1 ; BYTE
.equ        SCANBREAK  =  0xF0 ; BYTE
.equ        SCANEXT  =  0xE0 ; BYTE
.equ        HSTSCROLL  =  0x00 ; BYTE
.equ        HSTPRINT  =  0x10 ; BYTE
.equ        HSTINS  =  0x16 ; BYTE
.equ        HSTHOME  =  0x00 ; BYTE
.equ        HSTPGUP  =  0x12 ; BYTE
.equ        HSTPGDN  =  0x03 ; BYTE
.equ        HSTDEL  =  0x08 ; BYTE
.equ        HSTEND  =  0x00 ; BYTE
.equ        HSTLEFT  =  0x13 ; BYTE
.equ        HSTRIGHT  =  0x04 ; BYTE
.equ        HSTUP  =  0x05 ; BYTE
.equ        HSTDN  =  0x18 ; BYTE
.equ        HSTRGUI  =  0x00 ; BYTE
.equ        HSTLGUI  =  0x00 ; BYTE
.equ        HSTAPPS  =  0x00 ; BYTE
.equ        HSTF1  =  0x80 ; BYTE
.equ        HSTF2  =  0x81 ; BYTE
.equ        HSTF3  =  0x82 ; BYTE
.equ        HSTF4  =  0x83 ; BYTE
.equ        HSTF5  =  0x84 ; BYTE
.equ        HSTF6  =  0x85 ; BYTE
.equ        HSTF7  =  0x86 ; BYTE
.equ        HSTF8  =  0x87 ; BYTE
.equ        HSTF9  =  0x88 ; BYTE
.equ        HSTF10  =  0x89 ; BYTE
.equ        HSTF11  =  0x8A ; BYTE
.equ        HSTF12  =  0x8B ; BYTE
.equ        WAITKON  =  0x0012 ; WORD
.equ        WAITKON2  =  0x032A ; WORD
.equ        ITP3_WHO_AM_I  =  0x01 ; BYTE
.equ        ITP3_ERROR_CODE  =  0x02 ; BYTE
.equ        ITP3_CONOUT  =  0x03 ; BYTE
.equ        ITP3_CONST  =  0x04 ; BYTE
.equ        ITP3_CONIN  =  0x05 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
STEUER_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
TEXT_STRING:   ; String(15)
.byte     1     ; STRING-Laenge
.byte     15
BITCNTR:   ; Byte
.byte     1
KEYBSTATE:   ; Byte
.byte     1
LEDSTATE:   ; Byte
.byte     1
LOCALBYTE:   ; Byte
.byte     1
KBSHIFTSTATE:   ; Byte
.byte     1
TMPBYTE:   ; Byte
.byte     1
CAPS_PRESSED:   ; Boolean
.byte     1
NUM_PRESSED:   ; Boolean
.byte     1
SCROLL_PRESSED:   ; Boolean
.byte     1
DOCLICK:   ; Boolean
.byte     1
INITFAILED:   ; Boolean
.byte     1
LOCALMODE:   ; Boolean
.byte     1
CH:   ; Char
.byte     1
SCANBUFFERPTR:   ; Word
.byte     2
KEYBUFFERPTR:   ; Word
.byte     2
SCAN_ZEICHEN:   ; Byte
.byte     1
TASTATURLAYOUT_DE:   ; Boolean
.byte     1
EEPROM_TEMP:   ; Byte
.byte     1
BYTE_HEX_STRING:   ; String(2)
.byte     1     ; STRING-Laenge
.byte     2
BYTE_DEZ_STRING:   ; String(3)
.byte     1     ; STRING-Laenge
.byte     3
WORD_HEX_STRING:   ; String(4)
.byte     1     ; STRING-Laenge
.byte     4
DWORD_HEX_STRING:   ; String(8)
.byte     1     ; STRING-Laenge
.byte     8
 
SCANBUFFER:
.byte     33
KEYBUFFER:
.byte     33
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; External Interrupt Request 0
.ORG INT0addr
        JMP        EI_INT0
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (NEGATION_BYTE)
NEGATION_BYTE:
 
; ASM
COM    R0
 
 
; RESULT Byte-Variable - FUNCTION (NEGATION_BYTE)
        MOV        R1, R0
 
; Ende Byte - FUNCTION (NEGATION_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (NEGATION_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x032A)
        LDI        R17, HIGH(0x032A)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOHEXSTRING)
BYTETOHEXSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOHEXSTRING)
        RET
 
; PROCEDURE - Anfang (BYTETODEZSTRING)
BYTETODEZSTRING:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; WHILE DO ...
M_WHILE_065:
 
; WHILE - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x64)
        LDI        R18, 0x64
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_066
        RJMP       M_WHILE_067
M_WHILE_066:
 
; WHILE DO ...
        RJMP       M_WHILE_065
M_WHILE_067:
 
; PROCEDURE - Ende (BYTETODEZSTRING)
        RET
 
; FUNCTION - Anfang (HEXSTRINGTOBYTE)
HEXSTRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_071:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_078
        CLR        R16
        RJMP       M_VERGL_079
M_VERGL_078:
        SER        R16
M_VERGL_079:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_075
        RJMP       M_IF_076
M_IF_075:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_076:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (HEXSTRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (HEXSTRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (HEXSTRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (WORDTOHEXSTRING)
WORDTOHEXSTRING:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT_WORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_LOW)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT_WORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_HIGH)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_HIGH) retten
        MOV        R19, R3
 
; lokalen Parameter (BYTE_HIGH) an Prozedur (BYTETOHEXSTRING)
        MOV        R0, R19
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOHEXSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WORD_HEX_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_080
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_080:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_082
M_PRG_CONST_STRING_081:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_081
M_PRG_CONST_STRING_082:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_084
        MOV        R16, R17
M_PRG_CONST_STRING_083:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_083
M_PRG_CONST_STRING_084:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_LOW) retten
        MOV        R18, R2
 
; lokalen Parameter (BYTE_LOW) an Prozedur (BYTETOHEXSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOHEXSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WORD_HEX_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_085
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_085:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_087
M_PRG_CONST_STRING_086:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_086
M_PRG_CONST_STRING_087:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_088
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_088:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_090
M_PRG_CONST_STRING_089:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_089
M_PRG_CONST_STRING_090:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_092
        MOV        R16, R17
M_PRG_CONST_STRING_091:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_091
M_PRG_CONST_STRING_092:
        ST         -Z, R17
 
; PROCEDURE - Ende (WORDTOHEXSTRING)
        RET
 
; FUNCTION - Anfang (HEXSTRINGTOWORD)
HEXSTRINGTOWORD:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_093
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_093:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_095
        MOV        R16, R17
M_PRG_CONST_STRING_094:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_094
M_PRG_CONST_STRING_095:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_096
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_096:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_098
M_PRG_CONST_STRING_097:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_097
M_PRG_CONST_STRING_098:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_099
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_099:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0101
        MOV        R16, R17
M_PRG_CONST_STRING_0100:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0100
M_PRG_CONST_STRING_0101:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (HEXSTRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (HEXSTRINGTOBYTE)
        CALL       HEXSTRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (HEXSTRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0102
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0102:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0104
        MOV        R16, R17
M_PRG_CONST_STRING_0103:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0103
M_PRG_CONST_STRING_0104:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0105
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0105:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0107
M_PRG_CONST_STRING_0106:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0106
M_PRG_CONST_STRING_0107:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0108
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0108:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0110
        MOV        R16, R17
M_PRG_CONST_STRING_0109:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0109
M_PRG_CONST_STRING_0110:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (HEXSTRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (HEXSTRINGTOBYTE)
        CALL       HEXSTRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (HEXSTRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (S2W2)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; RESULT Word-Variable - FUNCTION (HEXSTRINGTOWORD)
        MOV        R0, R3
        MOV        R1, R4
 
; Ende Word - FUNCTION (HEXSTRINGTOWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; FUNCTION - Ende (HEXSTRINGTOWORD)
        RET
 
; PROCEDURE - Anfang (DWORDTOHEXSTRING)
DWORDTOHEXSTRING:
 
; Zuweisung Quelle - Ausdruck / DWLow(WERT_DWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_LOW)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / DWHigh(WERT_DWORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_HIGH)
        MOV        R6, R16
        MOV        R7, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_HIGH) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (WORD_HIGH) an Prozedur (WORDTOHEXSTRING)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf PROCEDURE (WORDTOHEXSTRING)
        CALL       WORDTOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOHEXSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (DWORD_HEX_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0111
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0111:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0113
M_PRG_CONST_STRING_0112:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0112
M_PRG_CONST_STRING_0113:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_HEX_STRING)
        LDI        ZH, HIGH(DWORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0115
        MOV        R16, R17
M_PRG_CONST_STRING_0114:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0114
M_PRG_CONST_STRING_0115:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_LOW) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (WORD_LOW) an Prozedur (WORDTOHEXSTRING)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf PROCEDURE (WORDTOHEXSTRING)
        CALL       WORDTOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOHEXSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (DWORD_HEX_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(DWORD_HEX_STRING)
        LDI        ZH, HIGH(DWORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0116
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0116:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0118
M_PRG_CONST_STRING_0117:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0117
M_PRG_CONST_STRING_0118:
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0119
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0119:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0121
M_PRG_CONST_STRING_0120:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0120
M_PRG_CONST_STRING_0121:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_HEX_STRING)
        LDI        ZH, HIGH(DWORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0123
        MOV        R16, R17
M_PRG_CONST_STRING_0122:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0122
M_PRG_CONST_STRING_0123:
        ST         -Z, R17
 
; PROCEDURE - Ende (DWORDTOHEXSTRING)
        RET
 
; FUNCTION - Anfang (EEPROM_READ)
EEPROM_READ:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (EE_ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (EEARL)
        OUT        EEARL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (EEARH)
        OUT        EEARH, R16
 
; ASM
EEPROM_M1:
; Wait for completion of previous write
sbic EECR,EEPE
rjmp EEPROM_M1

; Start eeprom read by writing EERE
sbi EECR,EERE

 
 
; Zuweisung Quelle - Ausdruck / Byte-REG EEDR
        IN         R16, EEDR
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EE_DATEN)
        MOV        R2, R16
 
; RESULT Byte-Variable - FUNCTION (EEPROM_READ)
        MOV        R1, R2
 
; Ende Byte - FUNCTION (EEPROM_READ)
        MOV        R16, R1
 
; FUNCTION - Ende (EEPROM_READ)
        RET
 
; PROCEDURE - Anfang (EEPROM_WRITE)
EEPROM_WRITE:
 
; ASM
EEPROM_M2:
; Wait for completion of previous write
sbic EECR,EEPE
rjmp EEPROM_M2

 
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (EE_ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (EEARL)
        OUT        EEARL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (EEARH)
        OUT        EEARH, R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (EE_DATEN)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (EEDR)
        OUT        EEDR, R16
 
; ASM
; Write logical one to EEMPE
sbi EECR,EEMPE
; Start eeprom write by setting EEPE
sbi EECR,EEPE

 
 
; PROCEDURE - Ende (EEPROM_WRITE)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (INIT_INT0)
INIT_INT0:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (EICRA)
        LDS        R16, EICRA
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EICRA)
        STS        EICRA, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG EIMSK
        IN         R16, EIMSK
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EIMSK)
        OUT        EIMSK, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG EIFR
        IN         R16, EIFR
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EIFR)
        OUT        EIFR, R16
 
; PROCEDURE - Ende (INIT_INT0)
        RET
 
; PROCEDURE - Anfang (TON_SIRENE)
TON_SIRENE:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DAUER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FREQUENZ)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0124:
 
; FOR TO DO - Word-Vergleichsteil (DOWNTO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R18, R16
        CPC        R19, R17
        BRCC       M_FTD_0125
        RJMP       M_FTD_0126
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0125:
 
; SetBit(SUMMER)
        SBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(SUMMER)
        CBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-DEC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        SUB        R18, R20
        CLR        R20
        SBC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0124
 
; FOR TO DO - Ende
M_FTD_0126:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FREQUENZ)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (DAUER)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0127:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0128
        RJMP       M_FTD_0129
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0128:
 
; SetBit(SUMMER)
        SBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(SUMMER)
        CBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0127
 
; FOR TO DO - Ende
M_FTD_0129:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (TON_SIRENE)
        RET
 
; PROCEDURE - Anfang (CLICK)
CLICK:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; PROCEDURE - Ende (CLICK)
        RET
 
; PROCEDURE - Anfang (TON_A)
TON_A:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DAUER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0064)
        LDI        R16, LOW(0x0064)
        LDI        R17, HIGH(0x0064)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0130:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0131
        RJMP       M_FTD_0132
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0131:
 
; SetBit(SUMMER)
        SBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_A)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_A)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(SUMMER)
        CBI        PORTB, 0
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_A)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_A)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0130
 
; FOR TO DO - Ende
M_FTD_0132:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (TON_A)
        RET
 
; PROCEDURE - Anfang (WRITE_SCAN)
WRITE_SCAN:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0136
        CLR        R16
        RJMP       M_VERGL_0137
M_VERGL_0136:
        SER        R16
M_VERGL_0137:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0133
        RJMP       M_IF_0134
M_IF_0133:
 
; INC(SCANBUFFERPTR) - Word
        LDS        R24, SCANBUFFERPTR
        LDS        R25, SCANBUFFERPTR+1
        ADIW       R25:R24, 1
        STS        SCANBUFFERPTR, R24
        STS        SCANBUFFERPTR+1, R25
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; VAR ARRAY Ziel Zeiger berechnen (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WRITE_SCAN_VALUE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (SCANBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF_THEN - Ende
M_IF_0134:
 
; PROCEDURE - Ende (WRITE_SCAN)
        RET
 
; FUNCTION - Anfang (READ_SCAN)
READ_SCAN:
 
; ARRAY - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_SCAN_VALUE)
        MOV        R1, R16
 
; DEC(SCANBUFFERPTR) - Word
        LDS        R24, SCANBUFFERPTR
        LDS        R25, SCANBUFFERPTR+1
        SBIW       R25:R24, 1
        STS        SCANBUFFERPTR, R24
        STS        SCANBUFFERPTR+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0141
        CLR        R16
        RJMP       M_VERGL_0142
M_VERGL_0141:
        SER        R16
M_VERGL_0142:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0138
        RJMP       M_IF_0139
M_IF_0138:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SCAN_COUNTER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0143:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0144
        RJMP       M_FTD_0145
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0144:
 
; ARRAY - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SCAN_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; ARRAY - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (SCAN_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR ARRAY-1D (SCANBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0143
 
; FOR TO DO - Ende
M_FTD_0145:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0139:
 
; RESULT Byte-Variable - FUNCTION (READ_SCAN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (READ_SCAN)
        MOV        R16, R0
 
; FUNCTION - Ende (READ_SCAN)
        RET
 
; FUNCTION - Anfang (READ_KEY)
READ_KEY:
 
; Interrupt verbieten
        CLI
 
; ARRAY - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_KEY_VALUE)
        MOV        R1, R16
 
; DEC(KEYBUFFERPTR) - Word
        LDS        R24, KEYBUFFERPTR
        LDS        R25, KEYBUFFERPTR+1
        SBIW       R25:R24, 1
        STS        KEYBUFFERPTR, R24
        STS        KEYBUFFERPTR+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0149
        CLR        R16
        RJMP       M_VERGL_0150
M_VERGL_0149:
        SER        R16
M_VERGL_0150:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0146
        RJMP       M_IF_0147
M_IF_0146:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0151:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0152
        RJMP       M_FTD_0153
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0152:
 
; ARRAY - Ausdruck erster Faktor / lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; ARRAY - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR ARRAY-1D (KEYBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0151
 
; FOR TO DO - Ende
M_FTD_0153:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0147:
 
; Interrupt erlauben
        SEI
 
; RESULT Byte-Variable - FUNCTION (READ_KEY)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (READ_KEY)
        MOV        R16, R0
 
; FUNCTION - Ende (READ_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_KEY)
WRITE_KEY:
 
; Interrupt verbieten
        CLI
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0157
        CLR        R16
        RJMP       M_VERGL_0158
M_VERGL_0157:
        SER        R16
M_VERGL_0158:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0154
        RJMP       M_IF_0155
M_IF_0154:
 
; INC(KEYBUFFERPTR) - Word
        LDS        R24, KEYBUFFERPTR
        LDS        R25, KEYBUFFERPTR+1
        ADIW       R25:R24, 1
        STS        KEYBUFFERPTR, R24
        STS        KEYBUFFERPTR+1, R25
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; VAR ARRAY Ziel Zeiger berechnen (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WRITE_KEY_VALUE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (KEYBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF_THEN - Ende
M_IF_0155:
 
; Interrupt erlauben
        SEI
 
; PROCEDURE - Ende (WRITE_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_C_KEY)
WRITE_C_KEY:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(CKEY)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_C_KEY)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (WRITE_KEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (WRITE_KEY)
        CALL       WRITE_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_C_KEY)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (WRITE_C_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_TEXT)
WRITE_TEXT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Length(TEXT_STRING)
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        LD         R16, Z
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0159:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0160
        RJMP       M_FTD_0161
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0160:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (TEXT_STRING)
        CLR        R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_TEXT)
        PUSH       R0
        PUSH       R1
 
; Parameter (C1) retten
        MOV        R17, R1
 
; lokalen Parameter (C1) an Prozedur (WRITE_C_KEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (WRITE_C_KEY)
        CALL       WRITE_C_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_TEXT)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0159
 
; FOR TO DO - Ende
M_FTD_0161:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_TEXT)
        RET
 
; PROCEDURE - Anfang (SENDKEY)
SENDKEY:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0D)
        LDI        R16, 0x0D
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(B1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; CASE OF - lokaler Uebergabeparameter (SKEY)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element ($00)
        CPI        R16, 0x00
        BREQ       M_CASE_0164
        RJMP       M_CASE_0163
M_CASE_0164:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0163:
 
; CASE OF - vergleiche Einzel-Element ($80)
        CPI        R16, 0x80
        BREQ       M_CASE_0166
        RJMP       M_CASE_0165
M_CASE_0166:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('DIR')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0167
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0167:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0169
M_PRG_CONST_STRING_0168:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0168
M_PRG_CONST_STRING_0169:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0170
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0170:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0172
        MOV        R16, R17
M_PRG_CONST_STRING_0171:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0171
M_PRG_CONST_STRING_0172:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0165:
 
; CASE OF - vergleiche Einzel-Element ($81)
        CPI        R16, 0x81
        BREQ       M_CASE_0174
        RJMP       M_CASE_0173
M_CASE_0174:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('POWER')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0175
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0175:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0177
M_PRG_CONST_STRING_0176:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0176
M_PRG_CONST_STRING_0177:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0178
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0178:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0180
        MOV        R16, R17
M_PRG_CONST_STRING_0179:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0179
M_PRG_CONST_STRING_0180:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0173:
 
; CASE OF - vergleiche Einzel-Element ($82)
        CPI        R16, 0x82
        BREQ       M_CASE_0182
        RJMP       M_CASE_0181
M_CASE_0182:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('COPY')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0183
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0183:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0185
M_PRG_CONST_STRING_0184:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0184
M_PRG_CONST_STRING_0185:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0186
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0186:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0188
        MOV        R16, R17
M_PRG_CONST_STRING_0187:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0187
M_PRG_CONST_STRING_0188:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0181:
 
; CASE OF - vergleiche Einzel-Element ($83)
        CPI        R16, 0x83
        BREQ       M_CASE_0190
        RJMP       M_CASE_0189
M_CASE_0190:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('ERA')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0191
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0191:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0193
M_PRG_CONST_STRING_0192:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0192
M_PRG_CONST_STRING_0193:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0194
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0194:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0196
        MOV        R16, R17
M_PRG_CONST_STRING_0195:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0195
M_PRG_CONST_STRING_0196:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0189:
 
; CASE OF - vergleiche Einzel-Element ($84)
        CPI        R16, 0x84
        BREQ       M_CASE_0198
        RJMP       M_CASE_0197
M_CASE_0198:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('TYPEX')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0199
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0199:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0201
M_PRG_CONST_STRING_0200:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0200
M_PRG_CONST_STRING_0201:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0202
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0202:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0204
        MOV        R16, R17
M_PRG_CONST_STRING_0203:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0203
M_PRG_CONST_STRING_0204:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0197:
 
; CASE OF - vergleiche Einzel-Element ($85)
        CPI        R16, 0x85
        BREQ       M_CASE_0206
        RJMP       M_CASE_0205
M_CASE_0206:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('EXIT')
        LDI        ZL, LOW(2*M_CONST_STRING_5)
        LDI        ZH, HIGH(2*M_CONST_STRING_5)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0207
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0207:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0209
M_PRG_CONST_STRING_0208:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0208
M_PRG_CONST_STRING_0209:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0210
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0210:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0212
        MOV        R16, R17
M_PRG_CONST_STRING_0211:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0211
M_PRG_CONST_STRING_0212:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0205:
 
; CASE OF - vergleiche Einzel-Element ($86)
        CPI        R16, 0x86
        BREQ       M_CASE_0214
        RJMP       M_CASE_0213
M_CASE_0214:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('TURBO')
        LDI        ZL, LOW(2*M_CONST_STRING_6)
        LDI        ZH, HIGH(2*M_CONST_STRING_6)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0215
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0215:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0217
M_PRG_CONST_STRING_0216:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0216
M_PRG_CONST_STRING_0217:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0218
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0218:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0220
        MOV        R16, R17
M_PRG_CONST_STRING_0219:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0219
M_PRG_CONST_STRING_0220:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0213:
 
; CASE OF - vergleiche Einzel-Element ($87)
        CPI        R16, 0x87
        BREQ       M_CASE_0222
        RJMP       M_CASE_0221
M_CASE_0222:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('TURBO')
        LDI        ZL, LOW(2*M_CONST_STRING_7)
        LDI        ZH, HIGH(2*M_CONST_STRING_7)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0223
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0223:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0225
M_PRG_CONST_STRING_0224:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0224
M_PRG_CONST_STRING_0225:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0226
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0226:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0228
        MOV        R16, R17
M_PRG_CONST_STRING_0227:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0227
M_PRG_CONST_STRING_0228:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0221:
 
; CASE OF - vergleiche Einzel-Element ($88)
        CPI        R16, 0x88
        BREQ       M_CASE_0230
        RJMP       M_CASE_0229
M_CASE_0230:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_FC)
        LDI        R16, 0xFC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0231
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0231:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0233
        MOV        R16, R17
M_PRG_CONST_STRING_0232:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0232
M_PRG_CONST_STRING_0233:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0229:
 
; CASE OF - vergleiche Einzel-Element ($89)
        CPI        R16, 0x89
        BREQ       M_CASE_0235
        RJMP       M_CASE_0234
M_CASE_0235:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_FD)
        LDI        R16, 0xFD
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0236
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0236:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0238
        MOV        R16, R17
M_PRG_CONST_STRING_0237:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0237
M_PRG_CONST_STRING_0238:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0234:
 
; CASE OF - vergleiche Einzel-Element ($8A)
        CPI        R16, 0x8A
        BREQ       M_CASE_0240
        RJMP       M_CASE_0239
M_CASE_0240:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_FE)
        LDI        R16, 0xFE
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0241
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0241:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0243
        MOV        R16, R17
M_PRG_CONST_STRING_0242:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0242
M_PRG_CONST_STRING_0243:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0239:
 
; CASE OF - vergleiche Einzel-Element ($8B)
        CPI        R16, 0x8B
        BREQ       M_CASE_0245
        RJMP       M_CASE_0244
M_CASE_0245:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_FF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0246
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0246:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0248
        MOV        R16, R17
M_PRG_CONST_STRING_0247:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0247
M_PRG_CONST_STRING_0248:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0244:
 
; CASE OF - vergleiche Einzel-Element ($90)
        CPI        R16, 0x90
        BREQ       M_CASE_0250
        RJMP       M_CASE_0249
M_CASE_0250:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('DE')
        LDI        ZL, LOW(2*M_CONST_STRING_8)
        LDI        ZH, HIGH(2*M_CONST_STRING_8)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0251
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0251:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0253
M_PRG_CONST_STRING_0252:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0252
M_PRG_CONST_STRING_0253:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0254
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0254:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0256
        MOV        R16, R17
M_PRG_CONST_STRING_0255:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0255
M_PRG_CONST_STRING_0256:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0249:
 
; CASE OF - vergleiche Einzel-Element ($91)
        CPI        R16, 0x91
        BREQ       M_CASE_0258
        RJMP       M_CASE_0257
M_CASE_0258:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('EN')
        LDI        ZL, LOW(2*M_CONST_STRING_9)
        LDI        ZH, HIGH(2*M_CONST_STRING_9)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0259
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0259:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0261
M_PRG_CONST_STRING_0260:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0260
M_PRG_CONST_STRING_0261:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0262
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0262:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0264
        MOV        R16, R17
M_PRG_CONST_STRING_0263:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0263
M_PRG_CONST_STRING_0264:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
M_CASE_0257:
 
; CASE OF - vergleiche Einzel-Element ($92)
        CPI        R16, 0x92
        BREQ       M_CASE_0266
        RJMP       M_CASE_0265
M_CASE_0266:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (EEPROM_READ)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf Funktion (EEPROM_READ)
        CALL       EEPROM_READ
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (EEPROM_TEMP)
        STS        EEPROM_TEMP, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOHEXSTRING)
        LDS        R0, EEPROM_TEMP
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('EEPROM=')
        LDI        ZL, LOW(2*M_CONST_STRING_10)
        LDI        ZH, HIGH(2*M_CONST_STRING_10)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0267
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0267:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0269
M_PRG_CONST_STRING_0268:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0268
M_PRG_CONST_STRING_0269:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0270
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0270:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0272
M_PRG_CONST_STRING_0271:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0271
M_PRG_CONST_STRING_0272:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0274
        MOV        R16, R17
M_PRG_CONST_STRING_0273:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0273
M_PRG_CONST_STRING_0274:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0275
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0275:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0277
M_PRG_CONST_STRING_0276:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0276
M_PRG_CONST_STRING_0277:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0278
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0278:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0280
        MOV        R16, R17
M_PRG_CONST_STRING_0279:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0279
M_PRG_CONST_STRING_0280:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0162
 
; CASE OF ELSE
M_CASE_0265:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_KEY)
        CALL       WRITE_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0162:
 
; PROCEDURE - Ende (SENDKEY)
        RET
 
; PROCEDURE - Anfang (SENDKEYCHAR)
SENDKEYCHAR:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(SKEY)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEYCHAR)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (SENDKEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEYCHAR)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (SENDKEYCHAR)
        RET
 
; ISR - Einsprung
EI_INT0:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
PUSH   R18
 
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0281
        RJMP       M_IF_0282
M_IF_0281:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0283
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0282:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (BITCNTR)
        LDS        R16, BITCNTR
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0287
        CLR        R16
        RJMP       M_VERGL_0288
M_VERGL_0287:
        SER        R16
M_VERGL_0288:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0284
        RJMP       M_IF_0285
M_IF_0284:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (BITCNTR)
        LDS        R16, BITCNTR
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0B)
        LDI        R18, 0x0B
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0292
        CLR        R16
        RJMP       M_VERGL_0293
M_VERGL_0292:
        SER        R16
M_VERGL_0293:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0289
        RJMP       M_IF_0290
M_IF_0289:
 
; SHR(TMPBYTE) - Byte
        LDS        R16, TMPBYTE
        LSR        R16
        STS        TMPBYTE, R16
 
; IF THEN - Ausdruck /; BitHigh(KEY_DAT_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0297
        CLR        R16
        RJMP       M_VERGL_0298
M_VERGL_0297:
        SER        R16
M_VERGL_0298:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0294
        RJMP       M_IF_0295
M_IF_0294:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TMPBYTE)
        LDS        R16, TMPBYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x80)
        LDI        R18, 0x80
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (TMPBYTE)
        STS        TMPBYTE, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0296
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0295:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TMPBYTE)
        LDS        R16, TMPBYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x7F)
        LDI        R18, 0x7F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (TMPBYTE)
        STS        TMPBYTE, R16
 
; IF_THEN_ELSE - Ende
M_IF_0296:
 
; IF_THEN - Ende
M_IF_0290:
 
; IF_THEN - Ende
M_IF_0285:
 
; DEC(BITCNTR) - Byte
        LDS        R16, BITCNTR
        DEC        R16
        STS        BITCNTR, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (BITCNTR)
        LDS        R16, BITCNTR
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0302
        CLR        R16
        RJMP       M_VERGL_0303
M_VERGL_0302:
        SER        R16
M_VERGL_0303:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0299
        RJMP       M_IF_0300
M_IF_0299:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; IF THEN - Ausdruck / Byte-VAR (LOCALMODE)
        LDS        R16, LOCALMODE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0304
        RJMP       M_IF_0305
M_IF_0304:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (TMPBYTE)
        LDS        R16, TMPBYTE
 
; Zuweisung Ziel /  VAR (LOCALBYTE)
        STS        LOCALBYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOCALMODE)
        STS        LOCALMODE, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0306
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0305:
 
; ASM
PUSH   R0
PUSH   R17
PUSH   R19
PUSH   R24
PUSH   R25
PUSH   ZL
PUSH   ZH
 
 
; Byte-Parameter(1) fuer PROCEDURE (WRITE_SCAN)
        LDS        R0, TMPBYTE
 
; Aufruf PROCEDURE (WRITE_SCAN)
        CALL       WRITE_SCAN
 
; ASM
POP   ZH
POP   ZL
POP   R25
POP   R24
POP   R19
POP   R17
POP   R0
 
 
; IF_THEN_ELSE - Ende
M_IF_0306:
 
; IF_THEN - Ende
M_IF_0300:
 
; IF_THEN_ELSE - Ende
M_IF_0283:
 
; ASM
POP   R18
 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; PROCEDURE - Anfang (INITKEYB)
INITKEYB:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SCANBUFFERPTR)
        STS        SCANBUFFERPTR, R16
        STS        SCANBUFFERPTR+1, R17
 
; PROCEDURE - Ende (INITKEYB)
        RET
 
; PROCEDURE - Anfang (SET_KBD_CLK)
SET_KBD_CLK:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG EIFR
        IN         R16, EIFR
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EIFR)
        OUT        EIFR, R16
 
; SetBit(KEY_CLK_A)
        SBI        PORTD, 2
 
; ClearBit(KEY_CLK_D)
        CBI        DDRD, 2
 
; Interrupt erlauben
        SEI
 
; PROCEDURE - Ende (SET_KBD_CLK)
        RET
 
; PROCEDURE - Anfang (RESET_KBD_CLK)
RESET_KBD_CLK:
 
; Interrupt verbieten
        CLI
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; ClearBit(KEY_CLK_A)
        CBI        PORTD, 2
 
; SetBit(KEY_CLK_D)
        SBI        DDRD, 2
 
; PROCEDURE - Ende (RESET_KBD_CLK)
        RET
 
; FUNCTION - Anfang (NOT_PARITY)
NOT_PARITY:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B4)
        MOV        R5, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R5
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0307:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0308
        RJMP       M_FTD_0309
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0308:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (DAS_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0313
        CLR        R16
        RJMP       M_VERGL_0314
M_VERGL_0313:
        SER        R16
M_VERGL_0314:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0310
        RJMP       M_IF_0311
M_IF_0310:
 
; INC(B3) - Byte
        INC        R4
 
; IF_THEN - Ende
M_IF_0311:
 
; SHR(DAS_BYTE) - Byte
        LSR        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R5
        INC        R17
        MOV        R5, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0307
 
; FOR TO DO - Ende
M_FTD_0309:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B3)
        MOV        R16, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0318
        CLR        R16
        RJMP       M_VERGL_0319
M_VERGL_0318:
        SER        R16
M_VERGL_0319:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0315
        RJMP       M_IF_0316
M_IF_0315:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0317
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0316:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_0317:
 
; RESULT Byte-Variable - FUNCTION (NOT_PARITY)
        MOV        R1, R2
 
; Ende Byte - FUNCTION (NOT_PARITY)
        MOV        R16, R1
 
; FUNCTION - Ende (NOT_PARITY)
        RET
 
; PROCEDURE - Anfang (SENDTOKBD)
SENDTOKBD:
 
; Interrupt verbieten
        CLI
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
 
; Aufruf Funktion (NOT_PARITY)
        CALL       NOT_PARITY
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (P)
        MOV        R1, R16
 
; ClearBit(KEY_CLK_D)
        CBI        DDRD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0320:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0323
        CLR        R16
        RJMP       M_VERGL_0324
M_VERGL_0323:
        SER        R16
M_VERGL_0324:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0321
        RJMP       M_WHILE_0322
M_WHILE_0321:
 
; DEC(W) - Word
        MOVW       R25:R24, R3:R2
        SBIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0328
        CLR        R16
        RJMP       M_VERGL_0329
M_VERGL_0328:
        SER        R16
M_VERGL_0329:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0325
        RJMP       M_IF_0326
M_IF_0325:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN - Ende
M_IF_0326:
 
; WHILE DO ...
        RJMP       M_WHILE_0320
M_WHILE_0322:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0333
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0334
M_VERGL_0333:
        SER        R16
M_VERGL_0334:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0330
        RJMP       M_IF_0331
M_IF_0330:
 
; SetBit(KEY_CLK_D)
        SBI        DDRD, 2
 
; ClearBit(KEY_CLK_A)
        CBI        PORTD, 2
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(KEY_DAT_A)
        CBI        PORTD, 3
 
; SetBit(KEY_DAT_D)
        SBI        DDRD, 3
 
; SetBit(KEY_CLK_A)
        SBI        PORTD, 2
 
; ClearBit(KEY_CLK_D)
        CBI        DDRD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0335:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0338
        CLR        R16
        RJMP       M_VERGL_0339
M_VERGL_0338:
        SER        R16
M_VERGL_0339:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0336
        RJMP       M_WHILE_0337
M_WHILE_0336:
 
; DEC(W) - Word
        MOVW       R25:R24, R3:R2
        SBIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0343
        CLR        R16
        RJMP       M_VERGL_0344
M_VERGL_0343:
        SER        R16
M_VERGL_0344:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0340
        RJMP       M_IF_0341
M_IF_0340:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN - Ende
M_IF_0341:
 
; WHILE DO ...
        RJMP       M_WHILE_0335
M_WHILE_0337:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0348
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0349
M_VERGL_0348:
        SER        R16
M_VERGL_0349:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0345
        RJMP       M_IF_0346
M_IF_0345:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (B1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R8, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R8
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0350:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0351
        RJMP       M_FTD_0352
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0351:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R7, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R7
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0356
        CLR        R16
        RJMP       M_VERGL_0357
M_VERGL_0356:
        SER        R16
M_VERGL_0357:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0353
        RJMP       M_IF_0354
M_IF_0353:
 
; ClearBit(KEY_DAT_A)
        CBI        PORTD, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0355
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0354:
 
; SetBit(KEY_DAT_A)
        SBI        PORTD, 3
 
; IF_THEN_ELSE - Ende
M_IF_0355:
 
; SetBit(LED_RT)
        SBI        PORTB, 2
 
; WHILE DO ...
M_WHILE_0358:
 
; WHILE - Ausdruck /; BitLow(KEY_CLK_E)
        IN         R16, PIND
        BST        R16, 2
        BRTC       M_VERGL_0361
        CLR        R16
        RJMP       M_VERGL_0362
M_VERGL_0361:
        SER        R16
M_VERGL_0362:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0359
        RJMP       M_WHILE_0360
M_WHILE_0359:
 
; WHILE DO ...
        RJMP       M_WHILE_0358
M_WHILE_0360:
 
; WHILE DO ...
M_WHILE_0363:
 
; WHILE - Ausdruck /; BitHigh(KEY_CLK_E)
        IN         R16, PIND
        BST        R16, 2
        BRTS       M_VERGL_0366
        CLR        R16
        RJMP       M_VERGL_0367
M_VERGL_0366:
        SER        R16
M_VERGL_0367:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0364
        RJMP       M_WHILE_0365
M_WHILE_0364:
 
; WHILE DO ...
        RJMP       M_WHILE_0363
M_WHILE_0365:
 
; ClearBit(LED_RT)
        CBI        PORTB, 2
 
; SHR(TEST) - Byte
        LSR        R6
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R8
        INC        R17
        MOV        R8, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0350
 
; FOR TO DO - Ende
M_FTD_0352:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (P)
        MOV        R16, R1
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0368
        RJMP       M_IF_0369
M_IF_0368:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (REG)
        MOV        R16, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (REG)
        MOV        R5, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0370
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0369:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (REG)
        MOV        R16, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xFE)
        LDI        R18, 0xFE
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (REG)
        MOV        R5, R16
 
; IF_THEN_ELSE - Ende
M_IF_0370:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (REG)
        MOV        R16, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R7, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R7
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0374
        CLR        R16
        RJMP       M_VERGL_0375
M_VERGL_0374:
        SER        R16
M_VERGL_0375:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0371
        RJMP       M_IF_0372
M_IF_0371:
 
; ClearBit(KEY_DAT_A)
        CBI        PORTD, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0373
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0372:
 
; SetBit(KEY_DAT_A)
        SBI        PORTD, 3
 
; IF_THEN_ELSE - Ende
M_IF_0373:
 
; SetBit(LED_RT)
        SBI        PORTB, 2
 
; WHILE DO ...
M_WHILE_0376:
 
; WHILE - Ausdruck /; BitLow(KEY_CLK_E)
        IN         R16, PIND
        BST        R16, 2
        BRTC       M_VERGL_0379
        CLR        R16
        RJMP       M_VERGL_0380
M_VERGL_0379:
        SER        R16
M_VERGL_0380:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0377
        RJMP       M_WHILE_0378
M_WHILE_0377:
 
; WHILE DO ...
        RJMP       M_WHILE_0376
M_WHILE_0378:
 
; WHILE DO ...
M_WHILE_0381:
 
; WHILE - Ausdruck /; BitHigh(KEY_CLK_E)
        IN         R16, PIND
        BST        R16, 2
        BRTS       M_VERGL_0384
        CLR        R16
        RJMP       M_VERGL_0385
M_VERGL_0384:
        SER        R16
M_VERGL_0385:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0382
        RJMP       M_WHILE_0383
M_WHILE_0382:
 
; WHILE DO ...
        RJMP       M_WHILE_0381
M_WHILE_0383:
 
; ClearBit(LED_RT)
        CBI        PORTB, 2
 
; SetBit(KEY_DAT_A)
        SBI        PORTD, 3
 
; WHILE DO ...
M_WHILE_0386:
 
; WHILE - Ausdruck /; BitLow(KEY_CLK_E)
        IN         R16, PIND
        BST        R16, 2
        BRTC       M_VERGL_0389
        CLR        R16
        RJMP       M_VERGL_0390
M_VERGL_0389:
        SER        R16
M_VERGL_0390:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0387
        RJMP       M_WHILE_0388
M_WHILE_0387:
 
; WHILE DO ...
        RJMP       M_WHILE_0386
M_WHILE_0388:
 
; ClearBit(KEY_DAT_D)
        CBI        DDRD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0391:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0394
        CLR        R16
        RJMP       M_VERGL_0395
M_VERGL_0394:
        SER        R16
M_VERGL_0395:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0392
        RJMP       M_WHILE_0393
M_WHILE_0392:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0399
        CLR        R16
        RJMP       M_VERGL_0400
M_VERGL_0399:
        SER        R16
M_VERGL_0400:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0396
        RJMP       M_IF_0397
M_IF_0396:
 
; INC(W) - Word
        MOVW       R25:R24, R3:R2
        ADIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; IF_THEN - Ende
M_IF_0397:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0404
        CLR        R16
        RJMP       M_VERGL_0405
M_VERGL_0404:
        SER        R16
M_VERGL_0405:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0401
        RJMP       M_IF_0402
M_IF_0401:
 
; INC(W) - Word
        MOVW       R25:R24, R3:R2
        ADIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; IF_THEN - Ende
M_IF_0402:
 
; WHILE DO ...
        RJMP       M_WHILE_0391
M_WHILE_0393:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0406:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0409
        CLR        R16
        RJMP       M_VERGL_0410
M_VERGL_0409:
        SER        R16
M_VERGL_0410:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0407
        RJMP       M_WHILE_0408
M_WHILE_0407:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0414
        CLR        R16
        RJMP       M_VERGL_0415
M_VERGL_0414:
        SER        R16
M_VERGL_0415:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0411
        RJMP       M_IF_0412
M_IF_0411:
 
; INC(W) - Word
        MOVW       R25:R24, R3:R2
        ADIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; IF_THEN - Ende
M_IF_0412:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PIND
        IN         R16, PIND
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0419
        CLR        R16
        RJMP       M_VERGL_0420
M_VERGL_0419:
        SER        R16
M_VERGL_0420:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0416
        RJMP       M_IF_0417
M_IF_0416:
 
; INC(W) - Word
        MOVW       R25:R24, R3:R2
        ADIW       R25:R24, 1
        MOVW       R3:R2, R25:R24
 
; IF_THEN - Ende
M_IF_0417:
 
; WHILE DO ...
        RJMP       M_WHILE_0406
M_WHILE_0408:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
 
; Aufruf PROCEDURE (RESET_KBD_CLK)
        CALL       RESET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (LOCALMODE)
        STS        LOCALMODE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
 
; Aufruf PROCEDURE (SET_KBD_CLK)
        CALL       SET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0421:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0424
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0425
M_VERGL_0424:
        SER        R16
M_VERGL_0425:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0422
        RJMP       M_WHILE_0423
M_WHILE_0422:
 
; IF THEN - Ausdruck / Byte-VAR (LOCALMODE)
        LDS        R16, LOCALMODE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0426
        RJMP       M_IF_0427
M_IF_0426:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0428
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0427:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0428:
 
; WHILE DO ...
        RJMP       M_WHILE_0421
M_WHILE_0423:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0347
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0346:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (INITFAILED)
        STS        INITFAILED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0347:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0332
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0331:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (INITFAILED)
        STS        INITFAILED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0332:
 
; PROCEDURE - Ende (SENDTOKBD)
        RET
 
; PROCEDURE - Anfang (SET_KBD_STATE)
SET_KBD_STATE:
 
; Byte-Parameter(1) fuer PROCEDURE (SENDTOKBD)
        LDI        R16, 0xED
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDTOKBD)
        CALL       SENDTOKBD
 
; Byte-Parameter(1) fuer PROCEDURE (SENDTOKBD)
        LDS        R0, LEDSTATE
 
; Aufruf PROCEDURE (SENDTOKBD)
        CALL       SENDTOKBD
 
; PROCEDURE - Ende (SET_KBD_STATE)
        RET
 
; PROCEDURE - Anfang (KBDRESET)
KBDRESET:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (INITFAILED)
        STS        INITFAILED, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (RESET_KBD_CLK)
        CALL       RESET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOCALBYTE)
        STS        LOCALBYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; WHILE DO ...
M_WHILE_0429:
 
; WHILE - Ausdruck / lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R16, R0
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0430
        RJMP       M_WHILE_0431
M_WHILE_0430:
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDTOKBD)
        LDI        R16, 0xFF
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDTOKBD)
        CALL       SENDTOKBD
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (LOCALBYTE)
        LDS        R16, LOCALBYTE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xAA)
        LDI        R18, 0xAA
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0435
        CLR        R16
        RJMP       M_VERGL_0436
M_VERGL_0435:
        SER        R16
M_VERGL_0436:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0432
        RJMP       M_IF_0433
M_IF_0432:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0433:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (LOCALBYTE)
        LDS        R16, LOCALBYTE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xFA)
        LDI        R18, 0xFA
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0440
        CLR        R16
        RJMP       M_VERGL_0441
M_VERGL_0440:
        SER        R16
M_VERGL_0441:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0437
        RJMP       M_IF_0438
M_IF_0437:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0438:
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0442
        RJMP       M_IF_0443
M_IF_0442:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0443:
 
; WHILE DO ...
        RJMP       M_WHILE_0429
M_WHILE_0431:
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0445
        RJMP       M_IF_0446
M_IF_0445:
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (SET_KBD_CLK)
        CALL       SET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_LED_STATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SHIFTSTATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0447
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0446:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (LEDNUM)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (INITKEYB)
        CALL       INITKEYB
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0447:
 
; PROCEDURE - Ende (KBDRESET)
        RET
 
; PROCEDURE - Anfang (START_KEYBOARD)
START_KEYBOARD:
 
; Aufruf PROCEDURE (INITKEYB)
        CALL       INITKEYB
 
; Aufruf PROCEDURE (KBDRESET)
        CALL       KBDRESET
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0448
        RJMP       M_IF_0449
M_IF_0448:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0450
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0449:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0004)
        MOV        R0, R16
        LDI        R17, HIGH(0x0004)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; IF_THEN_ELSE - Ende
M_IF_0450:
 
; PROCEDURE - Ende (START_KEYBOARD)
        RET
 
; PROCEDURE - Anfang (SETZE_BIT_IN_KBSHIFTSTATE)
SETZE_BIT_IN_KBSHIFTSTATE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (SHIFT_TASTE)
        MOV        R18, R0
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; PROCEDURE - Ende (SETZE_BIT_IN_KBSHIFTSTATE)
        RET
 
; PROCEDURE - Anfang (LOESCHE_BIT_IN_KBSHIFTSTATE)
LOESCHE_BIT_IN_KBSHIFTSTATE:
 
; Retten der lokalen Parameter fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (NEGATION_BYTE)
        CALL       NEGATION_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R18, R1
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; PROCEDURE - Ende (LOESCHE_BIT_IN_KBSHIFTSTATE)
        RET
 
; PROCEDURE - Anfang (SETZE_BIT_IN_LEDSTATE)
SETZE_BIT_IN_LEDSTATE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (LEDSTATE)
        LDS        R16, LEDSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (STATE_LED)
        MOV        R18, R0
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; PROCEDURE - Ende (SETZE_BIT_IN_LEDSTATE)
        RET
 
; PROCEDURE - Anfang (LOESCHE_BIT_IN_LEDSTATE)
LOESCHE_BIT_IN_LEDSTATE:
 
; Retten der lokalen Parameter fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (NEGATION_BYTE)
        CALL       NEGATION_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (LEDSTATE)
        LDS        R16, LEDSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R18, R1
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; PROCEDURE - Ende (LOESCHE_BIT_IN_LEDSTATE)
        RET
 
; PROCEDURE - Anfang (SCAN_TO_KEY)
SCAN_TO_KEY:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(CURSCAN)
        MOV        R16, R0
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R2, R16
        MOV        R3, R17
 
; CASE OF - Byte-VAR (KEYBSTATE)
        LDS        R16, KEYBSTATE
 
; CASE OF - vergleiche Einzel-Element (KEYSTAT_BYTE1)
        CPI        R16, 0x01
        BREQ       M_CASE_0453
        RJMP       M_CASE_0452
M_CASE_0453:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE OF - lokaler Uebergabeparameter (CURSCAN)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (SCANEXT)
        CPI        R16, 0xE0
        BREQ       M_CASE_0456
        RJMP       M_CASE_0455
M_CASE_0456:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_E0)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0455:
 
; CASE OF - vergleiche Einzel-Element (SCANBREAK)
        CPI        R16, 0xF0
        BREQ       M_CASE_0458
        RJMP       M_CASE_0457
M_CASE_0458:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_F0)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0457:
 
; CASE OF - vergleiche Einzel-Element (KBDALT)
        CPI        R16, 0x11
        BREQ       M_CASE_0460
        RJMP       M_CASE_0459
M_CASE_0460:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0459:
 
; CASE OF - vergleiche Einzel-Element (KBDLSHIFT)
        CPI        R16, 0x12
        BREQ       M_CASE_0462
        RJMP       M_CASE_0461
M_CASE_0462:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0461:
 
; CASE OF - vergleiche Einzel-Element (KBDRSHIFT)
        CPI        R16, 0x59
        BREQ       M_CASE_0464
        RJMP       M_CASE_0463
M_CASE_0464:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0463:
 
; CASE OF - vergleiche Einzel-Element (KBDCTRL)
        CPI        R16, 0x14
        BREQ       M_CASE_0466
        RJMP       M_CASE_0465
M_CASE_0466:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x10
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0465:
 
; CASE OF - vergleiche Einzel-Element (KBDCAPS)
        CPI        R16, 0x58
        BREQ       M_CASE_0468
        RJMP       M_CASE_0467
M_CASE_0468:
 
; IF THEN - Ausdruck / Byte-VAR (CAPS_PRESSED)
        LDS        R16, CAPS_PRESSED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0469
        RJMP       M_IF_0470
M_IF_0469:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0471
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0470:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0475
        CLR        R16
        RJMP       M_VERGL_0476
M_VERGL_0475:
        SER        R16
M_VERGL_0476:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0472
        RJMP       M_IF_0473
M_IF_0472:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        CALL       LOESCHE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0474
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0473:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        CALL       SETZE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0474:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (CAPS_PRESSED)
        STS        CAPS_PRESSED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0471:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0467:
 
; CASE OF - vergleiche Einzel-Element (KBDNUM)
        CPI        R16, 0x77
        BREQ       M_CASE_0478
        RJMP       M_CASE_0477
M_CASE_0478:
 
; IF THEN - Ausdruck / Byte-VAR (NUM_PRESSED)
        LDS        R16, NUM_PRESSED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0479
        RJMP       M_IF_0480
M_IF_0479:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0481
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0480:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHNUM)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHNUM)
        LDI        R18, 0x02
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0485
        CLR        R16
        RJMP       M_VERGL_0486
M_VERGL_0485:
        SER        R16
M_VERGL_0486:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0482
        RJMP       M_IF_0483
M_IF_0482:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        CALL       LOESCHE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0484
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0483:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        CALL       SETZE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0484:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (NUM_PRESSED)
        STS        NUM_PRESSED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0481:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0477:
 
; CASE OF - vergleiche Einzel-Element (KBDSCROLL)
        CPI        R16, 0x7E
        BREQ       M_CASE_0488
        RJMP       M_CASE_0487
M_CASE_0488:
 
; IF THEN - Ausdruck / Byte-VAR (SCROLL_PRESSED)
        LDS        R16, SCROLL_PRESSED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0489
        RJMP       M_IF_0490
M_IF_0489:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0491
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0490:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHSCROLL)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHSCROLL)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0495
        CLR        R16
        RJMP       M_VERGL_0496
M_VERGL_0495:
        SER        R16
M_VERGL_0496:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0492
        RJMP       M_IF_0493
M_IF_0492:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        CALL       LOESCHE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0494
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0493:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        CALL       SETZE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0494:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SCROLL_PRESSED)
        STS        SCROLL_PRESSED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0491:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0487:
 
; CASE OF - vergleiche Einzel-Element (KBDENTER)
        CPI        R16, 0x5A
        BREQ       M_CASE_0498
        RJMP       M_CASE_0497
M_CASE_0498:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0497:
 
; CASE OF - vergleiche Einzel-Element (KBDSPACE)
        CPI        R16, 0x29
        BREQ       M_CASE_0500
        RJMP       M_CASE_0499
M_CASE_0500:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEYCHAR)
        LDI        R16, ' '
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEYCHAR)
        CALL       SENDKEYCHAR
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0499:
 
; CASE OF - vergleiche Einzel-Element (KBDBS)
        CPI        R16, 0x66
        BREQ       M_CASE_0502
        RJMP       M_CASE_0501
M_CASE_0502:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x7F
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0501:
 
; CASE OF - vergleiche Einzel-Element (KBDTAB)
        CPI        R16, 0x0D
        BREQ       M_CASE_0504
        RJMP       M_CASE_0503
M_CASE_0504:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x09
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0503:
 
; CASE OF - vergleiche Einzel-Element (KBDESC)
        CPI        R16, 0x76
        BREQ       M_CASE_0506
        RJMP       M_CASE_0505
M_CASE_0506:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x1B
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0505:
 
; CASE OF - vergleiche Einzel-Element (KBDF1)
        CPI        R16, 0x05
        BREQ       M_CASE_0508
        RJMP       M_CASE_0507
M_CASE_0508:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x80
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0507:
 
; CASE OF - vergleiche Einzel-Element (KBDF2)
        CPI        R16, 0x06
        BREQ       M_CASE_0510
        RJMP       M_CASE_0509
M_CASE_0510:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x81
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0509:
 
; CASE OF - vergleiche Einzel-Element (KBDF3)
        CPI        R16, 0x04
        BREQ       M_CASE_0512
        RJMP       M_CASE_0511
M_CASE_0512:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x82
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0511:
 
; CASE OF - vergleiche Einzel-Element (KBDF4)
        CPI        R16, 0x0C
        BREQ       M_CASE_0514
        RJMP       M_CASE_0513
M_CASE_0514:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x83
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0513:
 
; CASE OF - vergleiche Einzel-Element (KBDF5)
        CPI        R16, 0x03
        BREQ       M_CASE_0516
        RJMP       M_CASE_0515
M_CASE_0516:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x84
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0515:
 
; CASE OF - vergleiche Einzel-Element (KBDF6)
        CPI        R16, 0x0B
        BREQ       M_CASE_0518
        RJMP       M_CASE_0517
M_CASE_0518:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x85
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0517:
 
; CASE OF - vergleiche Einzel-Element (KBDF7)
        CPI        R16, 0x83
        BREQ       M_CASE_0520
        RJMP       M_CASE_0519
M_CASE_0520:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x86
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0519:
 
; CASE OF - vergleiche Einzel-Element (KBDF8)
        CPI        R16, 0x0A
        BREQ       M_CASE_0522
        RJMP       M_CASE_0521
M_CASE_0522:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x87
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0521:
 
; CASE OF - vergleiche Einzel-Element (KBDF9)
        CPI        R16, 0x01
        BREQ       M_CASE_0524
        RJMP       M_CASE_0523
M_CASE_0524:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x88
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0523:
 
; CASE OF - vergleiche Einzel-Element (KBDF10)
        CPI        R16, 0x09
        BREQ       M_CASE_0526
        RJMP       M_CASE_0525
M_CASE_0526:
 
; IF THEN - Ausdruck / Byte-VAR (TASTATURLAYOUT_DE)
        LDS        R16, TASTATURLAYOUT_DE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0527
        RJMP       M_IF_0528
M_IF_0527:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TASTATURLAYOUT_DE)
        STS        TASTATURLAYOUT_DE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x91
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (TON_A)
        CALL       TON_A
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x00C8)
        MOV        R0, R16
        LDI        R17, HIGH(0x00C8)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (TON_A)
        CALL       TON_A
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (EEPROM_WRITE)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (EEPROM_WRITE)
        LDI        R16, 0x02
        MOV        R1, R16
 
; Aufruf PROCEDURE (EEPROM_WRITE)
        CALL       EEPROM_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0529
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0528:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (TASTATURLAYOUT_DE)
        STS        TASTATURLAYOUT_DE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x90
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (TON_A)
        CALL       TON_A
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (EEPROM_WRITE)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (EEPROM_WRITE)
        LDI        R16, 0x01
        MOV        R1, R16
 
; Aufruf PROCEDURE (EEPROM_WRITE)
        CALL       EEPROM_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0529:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0525:
 
; CASE OF - vergleiche Einzel-Element (KBDF11)
        CPI        R16, 0x78
        BREQ       M_CASE_0531
        RJMP       M_CASE_0530
M_CASE_0531:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x92
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0530:
 
; CASE OF - vergleiche Einzel-Element (KBDF12)
        CPI        R16, 0x07
        BREQ       M_CASE_0533
        RJMP       M_CASE_0532
M_CASE_0533:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x8B
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
M_CASE_0532:
 
; CASE OF - vergleiche Einzel-Element (KBDPAUSE)
        CPI        R16, 0xE1
        BREQ       M_CASE_0535
        RJMP       M_CASE_0534
M_CASE_0535:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0454
 
; CASE OF ELSE
M_CASE_0534:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_NULL)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHSHIFT)
        LDI        R18, 0x20
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHSHIFT)
        LDI        R18, 0x20
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0539
        CLR        R16
        RJMP       M_VERGL_0540
M_VERGL_0539:
        SER        R16
M_VERGL_0540:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0536
        RJMP       M_IF_0537
M_IF_0536:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0544
        CLR        R16
        RJMP       M_VERGL_0545
M_VERGL_0544:
        SER        R16
M_VERGL_0545:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0541
        RJMP       M_IF_0542
M_IF_0541:
 
; IF THEN - Ausdruck / Byte-VAR (TASTATURLAYOUT_DE)
        LDS        R16, TASTATURLAYOUT_DE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0546
        RJMP       M_IF_0547
M_IF_0546:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_NORMAL_DE)
        LDI        ZL, LOW(2*CODETAB_NORMAL_DE)
        LDI        ZH, HIGH(2*CODETAB_NORMAL_DE)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0548
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0547:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_NORMAL_EN)
        LDI        ZL, LOW(2*CODETAB_NORMAL_EN)
        LDI        ZH, HIGH(2*CODETAB_NORMAL_EN)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0548:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0543
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0542:
 
; IF THEN - Ausdruck / Byte-VAR (TASTATURLAYOUT_DE)
        LDS        R16, TASTATURLAYOUT_DE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0549
        RJMP       M_IF_0550
M_IF_0549:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_SHIFT_DE)
        LDI        ZL, LOW(2*CODETAB_SHIFT_DE)
        LDI        ZH, HIGH(2*CODETAB_SHIFT_DE)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0551
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0550:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_SHIFT_EN)
        LDI        ZL, LOW(2*CODETAB_SHIFT_EN)
        LDI        ZH, HIGH(2*CODETAB_SHIFT_EN)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0551:
 
; IF_THEN_ELSE - Ende
M_IF_0543:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0538
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0537:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0555
        CLR        R16
        RJMP       M_VERGL_0556
M_VERGL_0555:
        SER        R16
M_VERGL_0556:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0552
        RJMP       M_IF_0553
M_IF_0552:
 
; IF THEN - Ausdruck / Byte-VAR (TASTATURLAYOUT_DE)
        LDS        R16, TASTATURLAYOUT_DE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0557
        RJMP       M_IF_0558
M_IF_0557:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_SHIFT_DE)
        LDI        ZL, LOW(2*CODETAB_SHIFT_DE)
        LDI        ZH, HIGH(2*CODETAB_SHIFT_DE)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0559
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0558:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_SHIFT_EN)
        LDI        ZL, LOW(2*CODETAB_SHIFT_EN)
        LDI        ZH, HIGH(2*CODETAB_SHIFT_EN)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0559:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0554
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0553:
 
; IF THEN - Ausdruck / Byte-VAR (TASTATURLAYOUT_DE)
        LDS        R16, TASTATURLAYOUT_DE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0560
        RJMP       M_IF_0561
M_IF_0560:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_NORMAL_DE)
        LDI        ZL, LOW(2*CODETAB_NORMAL_DE)
        LDI        ZH, HIGH(2*CODETAB_NORMAL_DE)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0562
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0561:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_NORMAL_EN)
        LDI        ZL, LOW(2*CODETAB_NORMAL_EN)
        LDI        ZH, HIGH(2*CODETAB_NORMAL_EN)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0562:
 
; IF_THEN_ELSE - Ende
M_IF_0554:
 
; IF_THEN_ELSE - Ende
M_IF_0538:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCTRL)
        LDI        R18, 0x10
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCTRL)
        LDI        R18, 0x10
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0566
        CLR        R16
        RJMP       M_VERGL_0567
M_VERGL_0566:
        SER        R16
M_VERGL_0567:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0563
        RJMP       M_IF_0564
M_IF_0563:
 
; IF THEN - Ausdruck / Byte-VAR (TASTATURLAYOUT_DE)
        LDS        R16, TASTATURLAYOUT_DE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0568
        RJMP       M_IF_0569
M_IF_0568:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_CTRL_DE)
        LDI        ZL, LOW(2*CODETAB_CTRL_DE)
        LDI        ZH, HIGH(2*CODETAB_CTRL_DE)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0570
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0569:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_CTRL_EN)
        LDI        ZL, LOW(2*CODETAB_CTRL_EN)
        LDI        ZH, HIGH(2*CODETAB_CTRL_EN)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0570:
 
; IF_THEN - Ende
M_IF_0564:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHALT)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHALT)
        LDI        R18, 0x08
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0574
        CLR        R16
        RJMP       M_VERGL_0575
M_VERGL_0574:
        SER        R16
M_VERGL_0575:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0571
        RJMP       M_IF_0572
M_IF_0571:
 
; IF THEN - Ausdruck / Byte-VAR (TASTATURLAYOUT_DE)
        LDS        R16, TASTATURLAYOUT_DE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0576
        RJMP       M_IF_0577
M_IF_0576:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_ALT_DE)
        LDI        ZL, LOW(2*CODETAB_ALT_DE)
        LDI        ZH, HIGH(2*CODETAB_ALT_DE)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0578
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0577:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_ALT_EN)
        LDI        ZL, LOW(2*CODETAB_ALT_EN)
        LDI        ZH, HIGH(2*CODETAB_ALT_EN)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0578:
 
; IF_THEN - Ende
M_IF_0572:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEYCHAR)
        LDS        R0, CH
 
; Aufruf PROCEDURE (SENDKEYCHAR)
        CALL       SENDKEYCHAR
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0454:
 
; IF THEN - Ausdruck / Byte-VAR (DOCLICK)
        LDS        R16, DOCLICK
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0579
        RJMP       M_IF_0580
M_IF_0579:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (CLICK)
        CALL       CLICK
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0580:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0451
M_CASE_0452:
 
; CASE OF - vergleiche Einzel-Element (KEYSTAT_E0)
        CPI        R16, 0x02
        BREQ       M_CASE_0583
        RJMP       M_CASE_0582
M_CASE_0583:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE OF - lokaler Uebergabeparameter (CURSCAN)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (SCANBREAK)
        CPI        R16, 0xF0
        BREQ       M_CASE_0586
        RJMP       M_CASE_0585
M_CASE_0586:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_F0)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0585:
 
; CASE OF - vergleiche Einzel-Element (KBDALT)
        CPI        R16, 0x11
        BREQ       M_CASE_0588
        RJMP       M_CASE_0587
M_CASE_0588:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0587:
 
; CASE OF - vergleiche Einzel-Element (KBDCTRL)
        CPI        R16, 0x14
        BREQ       M_CASE_0590
        RJMP       M_CASE_0589
M_CASE_0590:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x10
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0589:
 
; CASE OF - vergleiche Einzel-Element (KBDENTER)
        CPI        R16, 0x5A
        BREQ       M_CASE_0592
        RJMP       M_CASE_0591
M_CASE_0592:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0591:
 
; CASE OF - vergleiche Einzel-Element (KBDUP)
        CPI        R16, 0x75
        BREQ       M_CASE_0594
        RJMP       M_CASE_0593
M_CASE_0594:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x05
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0593:
 
; CASE OF - vergleiche Einzel-Element (KBDDN)
        CPI        R16, 0x72
        BREQ       M_CASE_0596
        RJMP       M_CASE_0595
M_CASE_0596:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x18
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0595:
 
; CASE OF - vergleiche Einzel-Element (KBDLEFT)
        CPI        R16, 0x6B
        BREQ       M_CASE_0598
        RJMP       M_CASE_0597
M_CASE_0598:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x13
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0597:
 
; CASE OF - vergleiche Einzel-Element (KBDRIGHT)
        CPI        R16, 0x74
        BREQ       M_CASE_0600
        RJMP       M_CASE_0599
M_CASE_0600:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0599:
 
; CASE OF - vergleiche Einzel-Element (KBDPGUP)
        CPI        R16, 0x7D
        BREQ       M_CASE_0602
        RJMP       M_CASE_0601
M_CASE_0602:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x12
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0601:
 
; CASE OF - vergleiche Einzel-Element (KBDPGDN)
        CPI        R16, 0x7A
        BREQ       M_CASE_0604
        RJMP       M_CASE_0603
M_CASE_0604:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x03
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0603:
 
; CASE OF - vergleiche Einzel-Element (KBDHOME)
        CPI        R16, 0x6C
        BREQ       M_CASE_0606
        RJMP       M_CASE_0605
M_CASE_0606:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0605:
 
; CASE OF - vergleiche Einzel-Element (KBDINSERT)
        CPI        R16, 0x70
        BREQ       M_CASE_0608
        RJMP       M_CASE_0607
M_CASE_0608:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x16
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0607:
 
; CASE OF - vergleiche Einzel-Element (KBDDELETE)
        CPI        R16, 0x71
        BREQ       M_CASE_0610
        RJMP       M_CASE_0609
M_CASE_0610:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0609:
 
; CASE OF - vergleiche Einzel-Element (KBDEND)
        CPI        R16, 0x69
        BREQ       M_CASE_0612
        RJMP       M_CASE_0611
M_CASE_0612:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0611:
 
; CASE OF - vergleiche Einzel-Element (KBDRGUI)
        CPI        R16, 0x27
        BREQ       M_CASE_0614
        RJMP       M_CASE_0613
M_CASE_0614:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0613:
 
; CASE OF - vergleiche Einzel-Element (KBDLGUI)
        CPI        R16, 0x1F
        BREQ       M_CASE_0616
        RJMP       M_CASE_0615
M_CASE_0616:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0615:
 
; CASE OF - vergleiche Einzel-Element (KBDAPPS)
        CPI        R16, 0x2F
        BREQ       M_CASE_0618
        RJMP       M_CASE_0617
M_CASE_0618:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0584
M_CASE_0617:
 
; CASE OF - vergleiche Einzel-Element (KBDPRINT)
        CPI        R16, 0x12
        BREQ       M_CASE_0620
        RJMP       M_CASE_0619
M_CASE_0620:
 
; ENDCASE;
M_CASE_0619:
M_CASE_0584:
 
; IF THEN - Ausdruck / Byte-VAR (DOCLICK)
        LDS        R16, DOCLICK
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0621
        RJMP       M_IF_0622
M_IF_0621:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (CLICK)
        CALL       CLICK
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0622:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0451
M_CASE_0582:
 
; CASE OF - vergleiche Einzel-Element (KEYSTAT_F0)
        CPI        R16, 0x03
        BREQ       M_CASE_0625
        RJMP       M_CASE_0624
M_CASE_0625:
 
; CASE OF - lokaler Uebergabeparameter (CURSCAN)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (KBDALT)
        CPI        R16, 0x11
        BREQ       M_CASE_0628
        RJMP       M_CASE_0627
M_CASE_0628:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0627:
 
; CASE OF - vergleiche Einzel-Element (KBDLSHIFT)
        CPI        R16, 0x12
        BREQ       M_CASE_0630
        RJMP       M_CASE_0629
M_CASE_0630:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0629:
 
; CASE OF - vergleiche Einzel-Element (KBDRSHIFT)
        CPI        R16, 0x59
        BREQ       M_CASE_0632
        RJMP       M_CASE_0631
M_CASE_0632:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0631:
 
; CASE OF - vergleiche Einzel-Element (KBDCTRL)
        CPI        R16, 0x14
        BREQ       M_CASE_0634
        RJMP       M_CASE_0633
M_CASE_0634:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x10
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0633:
 
; CASE OF - vergleiche Einzel-Element (KBDCAPS)
        CPI        R16, 0x58
        BREQ       M_CASE_0636
        RJMP       M_CASE_0635
M_CASE_0636:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CAPS_PRESSED)
        STS        CAPS_PRESSED, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0635:
 
; CASE OF - vergleiche Einzel-Element (KBDNUM)
        CPI        R16, 0x77
        BREQ       M_CASE_0638
        RJMP       M_CASE_0637
M_CASE_0638:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (NUM_PRESSED)
        STS        NUM_PRESSED, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0626
M_CASE_0637:
 
; CASE OF - vergleiche Einzel-Element (KBDSCROLL)
        CPI        R16, 0x7E
        BREQ       M_CASE_0640
        RJMP       M_CASE_0639
M_CASE_0640:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SCROLL_PRESSED)
        STS        SCROLL_PRESSED, R16
 
; ENDCASE;
M_CASE_0639:
M_CASE_0626:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; ENDCASE;
M_CASE_0624:
M_CASE_0451:
 
; PROCEDURE - Ende (SCAN_TO_KEY)
        RET
 
; PROCEDURE - Anfang (ITP3_CLIENT_INIT)
ITP3_CLIENT_INIT:
 
; ClearBit(D0_D)
        CBI        DDRC, 0
 
; ClearBit(D1_D)
        CBI        DDRC, 1
 
; ClearBit(D2_D)
        CBI        DDRC, 2
 
; ClearBit(D3_D)
        CBI        DDRC, 3
 
; ClearBit(DS_D)
        CBI        DDRC, 4
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; PROCEDURE - Ende (ITP3_CLIENT_INIT)
        RET
 
; FUNCTION - Anfang (ITP3_HALBBYTE_EINLESEN)
ITP3_HALBBYTE_EINLESEN:
 
; SetBit(LED_GN)
        SBI        PORTB, 1
 
; WHILE DO ...
M_WHILE_0641:
 
; WHILE - Ausdruck /; BitHigh(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_0644
        CLR        R16
        RJMP       M_VERGL_0645
M_VERGL_0644:
        SER        R16
M_VERGL_0645:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0642
        RJMP       M_WHILE_0643
M_WHILE_0642:
 
; WHILE DO ...
        RJMP       M_WHILE_0641
M_WHILE_0643:
 
; ClearBit(LED_GN)
        CBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck /; BitHigh(D0_E)
        IN         R16, PINC
        BST        R16, 0
        BRTS       M_VERGL_0649
        CLR        R16
        RJMP       M_VERGL_0650
M_VERGL_0649:
        SER        R16
M_VERGL_0650:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0646
        RJMP       M_IF_0647
M_IF_0646:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0647:
 
; IF THEN - Ausdruck /; BitHigh(D1_E)
        IN         R16, PINC
        BST        R16, 1
        BRTS       M_VERGL_0654
        CLR        R16
        RJMP       M_VERGL_0655
M_VERGL_0654:
        SER        R16
M_VERGL_0655:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0651
        RJMP       M_IF_0652
M_IF_0651:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0652:
 
; IF THEN - Ausdruck /; BitHigh(D2_E)
        IN         R16, PINC
        BST        R16, 2
        BRTS       M_VERGL_0659
        CLR        R16
        RJMP       M_VERGL_0660
M_VERGL_0659:
        SER        R16
M_VERGL_0660:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0656
        RJMP       M_IF_0657
M_IF_0656:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0657:
 
; IF THEN - Ausdruck /; BitHigh(D3_E)
        IN         R16, PINC
        BST        R16, 3
        BRTS       M_VERGL_0664
        CLR        R16
        RJMP       M_VERGL_0665
M_VERGL_0664:
        SER        R16
M_VERGL_0665:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0661
        RJMP       M_IF_0662
M_IF_0661:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0662:
 
; ClearBit(DR_A)
        CBI        PORTC, 5
 
; SetBit(LED_GN)
        SBI        PORTB, 1
 
; WHILE DO ...
M_WHILE_0666:
 
; WHILE - Ausdruck /; BitLow(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_0669
        CLR        R16
        RJMP       M_VERGL_0670
M_VERGL_0669:
        SER        R16
M_VERGL_0670:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0667
        RJMP       M_WHILE_0668
M_WHILE_0667:
 
; WHILE DO ...
        RJMP       M_WHILE_0666
M_WHILE_0668:
 
; ClearBit(LED_GN)
        CBI        PORTB, 1
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; RESULT Byte-Variable - FUNCTION (ITP3_HALBBYTE_EINLESEN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_HALBBYTE_EINLESEN)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_HALBBYTE_EINLESEN)
        RET
 
; FUNCTION - Anfang (ITP3_BYTE_EINLESEN)
ITP3_BYTE_EINLESEN:
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; SetBit(DR_D)
        SBI        DDRC, 5
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_HALBBYTE_EINLESEN)
        CALL       ITP3_HALBBYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_HALBBYTE_EINLESEN)
        CALL       ITP3_HALBBYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; SHL(B1) - Byte
        LSL        R1
 
; SHL(B1) - Byte
        LSL        R1
 
; SHL(B1) - Byte
        LSL        R1
 
; SHL(B1) - Byte
        LSL        R1
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R2, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_BYTE_EINLESEN)
        MOV        R0, R2
 
; Ende Byte - FUNCTION (ITP3_BYTE_EINLESEN)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_BYTE_EINLESEN)
        RET
 
; PROCEDURE - Anfang (ITP3_HALBBYTE_AUSGEBEN)
ITP3_HALBBYTE_AUSGEBEN:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0674
        CLR        R16
        RJMP       M_VERGL_0675
M_VERGL_0674:
        SER        R16
M_VERGL_0675:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0671
        RJMP       M_IF_0672
M_IF_0671:
 
; ClearBit(D0_A)
        CBI        PORTC, 0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0673
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0672:
 
; SetBit(D0_A)
        SBI        PORTC, 0
 
; IF_THEN_ELSE - Ende
M_IF_0673:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0679
        CLR        R16
        RJMP       M_VERGL_0680
M_VERGL_0679:
        SER        R16
M_VERGL_0680:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0676
        RJMP       M_IF_0677
M_IF_0676:
 
; ClearBit(D1_A)
        CBI        PORTC, 1
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0678
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0677:
 
; SetBit(D1_A)
        SBI        PORTC, 1
 
; IF_THEN_ELSE - Ende
M_IF_0678:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0684
        CLR        R16
        RJMP       M_VERGL_0685
M_VERGL_0684:
        SER        R16
M_VERGL_0685:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0681
        RJMP       M_IF_0682
M_IF_0681:
 
; ClearBit(D2_A)
        CBI        PORTC, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0683
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0682:
 
; SetBit(D2_A)
        SBI        PORTC, 2
 
; IF_THEN_ELSE - Ende
M_IF_0683:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0689
        CLR        R16
        RJMP       M_VERGL_0690
M_VERGL_0689:
        SER        R16
M_VERGL_0690:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0686
        RJMP       M_IF_0687
M_IF_0686:
 
; ClearBit(D3_A)
        CBI        PORTC, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0688
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0687:
 
; SetBit(D3_A)
        SBI        PORTC, 3
 
; IF_THEN_ELSE - Ende
M_IF_0688:
 
; ClearBit(DR_A)
        CBI        PORTC, 5
 
; SetBit(LED_GN)
        SBI        PORTB, 1
 
; WHILE DO ...
M_WHILE_0691:
 
; WHILE - Ausdruck /; BitLow(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_0694
        CLR        R16
        RJMP       M_VERGL_0695
M_VERGL_0694:
        SER        R16
M_VERGL_0695:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0692
        RJMP       M_WHILE_0693
M_WHILE_0692:
 
; WHILE DO ...
        RJMP       M_WHILE_0691
M_WHILE_0693:
 
; ClearBit(LED_GN)
        CBI        PORTB, 1
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; PROCEDURE - Ende (ITP3_HALBBYTE_AUSGEBEN)
        RET
 
; PROCEDURE - Anfang (ITP3_BYTE_AUSGEBEN)
ITP3_BYTE_AUSGEBEN:
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; SetBit(DR_D)
        SBI        DDRC, 5
 
; SetBit(LED_GN)
        SBI        PORTB, 1
 
; WHILE DO ...
M_WHILE_0696:
 
; WHILE - Ausdruck /; BitHigh(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_0699
        CLR        R16
        RJMP       M_VERGL_0700
M_VERGL_0699:
        SER        R16
M_VERGL_0700:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0697
        RJMP       M_WHILE_0698
M_WHILE_0697:
 
; WHILE DO ...
        RJMP       M_WHILE_0696
M_WHILE_0698:
 
; ClearBit(LED_GN)
        CBI        PORTB, 1
 
; SetBit(D0_D)
        SBI        DDRC, 0
 
; SetBit(D1_D)
        SBI        DDRC, 1
 
; SetBit(D2_D)
        SBI        DDRC, 2
 
; SetBit(D3_D)
        SBI        DDRC, 3
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (ITP3_HALBBYTE_AUSGEBEN)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_HALBBYTE_AUSGEBEN)
        CALL       ITP3_HALBBYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        POP        R1
        POP        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SetBit(LED_GN)
        SBI        PORTB, 1
 
; WHILE DO ...
M_WHILE_0701:
 
; WHILE - Ausdruck /; BitHigh(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_0704
        CLR        R16
        RJMP       M_VERGL_0705
M_VERGL_0704:
        SER        R16
M_VERGL_0705:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0702
        RJMP       M_WHILE_0703
M_WHILE_0702:
 
; WHILE DO ...
        RJMP       M_WHILE_0701
M_WHILE_0703:
 
; ClearBit(LED_GN)
        CBI        PORTB, 1
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ITP3_HALBBYTE_AUSGEBEN)
        CALL       ITP3_HALBBYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        POP        R1
        POP        R0
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; ClearBit(D0_D)
        CBI        DDRC, 0
 
; ClearBit(D1_D)
        CBI        DDRC, 1
 
; ClearBit(D2_D)
        CBI        DDRC, 2
 
; ClearBit(D3_D)
        CBI        DDRC, 3
 
; PROCEDURE - Ende (ITP3_BYTE_AUSGEBEN)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_CONOUT)
ITP3_PRG_CONOUT:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONOUT)
        PUSH       R0
 
; Aufruf Funktion (ITP3_BYTE_EINLESEN)
        CALL       ITP3_BYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONOUT)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; PROCEDURE - Ende (ITP3_PRG_CONOUT)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_WHO_AM_I)
ITP3_PRG_WHO_AM_I:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x40)
        LDI        R16, 0x40
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_WHO_AM_I)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_BYTE_AUSGEBEN)
        CALL       ITP3_BYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_WHO_AM_I)
        POP        R0
 
; PROCEDURE - Ende (ITP3_PRG_WHO_AM_I)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_CONST)
ITP3_PRG_CONST:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0709
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0710
M_VERGL_0709:
        SER        R16
M_VERGL_0710:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0706
        RJMP       M_IF_0707
M_IF_0706:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0708
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0707:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Ende
M_IF_0708:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONST)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_BYTE_AUSGEBEN)
        CALL       ITP3_BYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONST)
        POP        R0
 
; PROCEDURE - Ende (ITP3_PRG_CONST)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_CONIN)
ITP3_PRG_CONIN:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONIN)
        PUSH       R0
 
; Aufruf Funktion (READ_KEY)
        CALL       READ_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONIN)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONIN)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_BYTE_AUSGEBEN)
        CALL       ITP3_BYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONIN)
        POP        R0
 
; PROCEDURE - Ende (ITP3_PRG_CONIN)
        RET
 
; PROCEDURE - Anfang (ITP3_SERVER_ABFRAGE)
ITP3_SERVER_ABFRAGE:
 
; IF THEN - Ausdruck /; BitLow(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_0714
        CLR        R16
        RJMP       M_VERGL_0715
M_VERGL_0714:
        SER        R16
M_VERGL_0715:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0711
        RJMP       M_IF_0712
M_IF_0711:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf Funktion (ITP3_BYTE_EINLESEN)
        CALL       ITP3_BYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CODE_BYTE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (CODE_BYTE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (ITP3_WHO_AM_I)
        CPI        R16, 0x01
        BREQ       M_CASE_0718
        RJMP       M_CASE_0717
M_CASE_0718:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_WHO_AM_I)
        CALL       ITP3_PRG_WHO_AM_I
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0716
M_CASE_0717:
 
; CASE OF - vergleiche Einzel-Element (ITP3_CONOUT)
        CPI        R16, 0x03
        BREQ       M_CASE_0720
        RJMP       M_CASE_0719
M_CASE_0720:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_CONOUT)
        CALL       ITP3_PRG_CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0716
M_CASE_0719:
 
; CASE OF - vergleiche Einzel-Element (ITP3_CONST)
        CPI        R16, 0x04
        BREQ       M_CASE_0722
        RJMP       M_CASE_0721
M_CASE_0722:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_CONST)
        CALL       ITP3_PRG_CONST
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0716
M_CASE_0721:
 
; CASE OF - vergleiche Einzel-Element (ITP3_CONIN)
        CPI        R16, 0x05
        BREQ       M_CASE_0724
        RJMP       M_CASE_0723
M_CASE_0724:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_CONIN)
        CALL       ITP3_PRG_CONIN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; ENDCASE;
M_CASE_0723:
M_CASE_0716:
 
; IF_THEN - Ende
M_IF_0712:
 
; PROCEDURE - Ende (ITP3_SERVER_ABFRAGE)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Byte-Parameter(1) fuer FUNCTION (EEPROM_READ)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf Funktion (EEPROM_READ)
        CALL       EEPROM_READ
 
; Zuweisung Ziel /  VAR (EEPROM_TEMP)
        STS        EEPROM_TEMP, R16
 
; CASE OF - Byte-VAR (EEPROM_TEMP)
        LDS        R16, EEPROM_TEMP
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_0727
        RJMP       M_CASE_0726
M_CASE_0727:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (TASTATURLAYOUT_DE)
        STS        TASTATURLAYOUT_DE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0725
M_CASE_0726:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_0729
        RJMP       M_CASE_0728
M_CASE_0729:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TASTATURLAYOUT_DE)
        STS        TASTATURLAYOUT_DE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0725
 
; CASE OF ELSE
M_CASE_0728:
 
; Byte-Parameter(1) fuer PROCEDURE (EEPROM_WRITE)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (EEPROM_WRITE)
        LDI        R16, 0x01
        MOV        R1, R16
 
; Aufruf PROCEDURE (EEPROM_WRITE)
        CALL       EEPROM_WRITE
 
; ENDCASE;
M_CASE_0725:
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; SetBit(LED_GN)
        SBI        PORTB, 1
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0005)
        MOV        R0, R16
        LDI        R17, HIGH(0x0005)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; ClearBit(LED_GN)
        CBI        PORTB, 1
 
; Aufruf PROCEDURE (ITP3_CLIENT_INIT)
        CALL       ITP3_CLIENT_INIT
 
; Aufruf PROCEDURE (INIT_INT0)
        CALL       INIT_INT0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CAPS_PRESSED)
        STS        CAPS_PRESSED, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (NUM_PRESSED)
        STS        NUM_PRESSED, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SCROLL_PRESSED)
        STS        SCROLL_PRESSED, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_LED_STATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SHIFTSTATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KEYBUFFERPTR)
        STS        KEYBUFFERPTR, R16
        STS        KEYBUFFERPTR+1, R17
 
; ClearBit(LED_GN)
        CBI        PORTB, 1
 
; ClearBit(SUMMER)
        CBI        PORTB, 0
 
; Aufruf PROCEDURE (START_KEYBOARD)
        CALL       START_KEYBOARD
 
; LOOP - Start_Marke
M_LOOP_0730:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0734
        CLR        R16
        RJMP       M_VERGL_0735
M_VERGL_0734:
        SER        R16
M_VERGL_0735:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0731
        RJMP       M_IF_0732
M_IF_0731:
 
; Aufruf Funktion (READ_SCAN)
        CALL       READ_SCAN
 
; Zuweisung Ziel /  VAR (SCAN_ZEICHEN)
        STS        SCAN_ZEICHEN, R16
 
; Byte-Parameter(1) fuer PROCEDURE (SCAN_TO_KEY)
        LDS        R0, SCAN_ZEICHEN
 
; Aufruf PROCEDURE (SCAN_TO_KEY)
        CALL       SCAN_TO_KEY
 
; IF_THEN - Ende
M_IF_0732:
 
; Aufruf PROCEDURE (ITP3_SERVER_ABFRAGE)
        CALL       ITP3_SERVER_ABFRAGE
 
; LOOP - Ende
        RJMP       M_LOOP_0730
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; TAKTFREQUENZ (C) WORD Wert=0x4800
; UBRR_VAL (C) BYTE Wert=0x10
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; CHAR_NULL (C) CHAR Wert=0x00
; CHAR_FC (C) CHAR Wert=0xFC
; CHAR_FD (C) CHAR Wert=0xFD
; CHAR_FE (C) CHAR Wert=0xFE
; CHAR_FF (C) CHAR Wert=0xFF
; NO_LED_STATE (C) BYTE Wert=0x00
; LEDSCROLL (C) BYTE Wert=0x01
; LEDNUM (C) BYTE Wert=0x02
; LEDCAPS (C) BYTE Wert=0x04
; KEYSTAT_BYTE1 (C) BYTE Wert=0x01
; KEYSTAT_E0 (C) BYTE Wert=0x02
; KEYSTAT_F0 (C) BYTE Wert=0x03
; NO_SHIFTSTATE (C) BYTE Wert=0x00
; SHSHIFT (C) BYTE Wert=0x20
; SHCTRL (C) BYTE Wert=0x10
; SHALT (C) BYTE Wert=0x08
; SHCAPS (C) BYTE Wert=0x04
; SHNUM (C) BYTE Wert=0x02
; SHSCROLL (C) BYTE Wert=0x01
; CODETAB_NORMAL_DE (A) 
; CODETAB_SHIFT_DE (A) 
; CODETAB_CTRL_DE (A) 
; CODETAB_ALT_DE (A) 
; CODETAB_NORMAL_EN (A) 
; CODETAB_SHIFT_EN (A) 
; CODETAB_CTRL_EN (A) 
; CODETAB_ALT_EN (A) 
; KBDNUM (C) BYTE Wert=0x77
; KBDCAPS (C) BYTE Wert=0x58
; KBDSCROLL (C) BYTE Wert=0x7E
; KBDALT (C) BYTE Wert=0x11
; KBDCTRL (C) BYTE Wert=0x14
; KBDLSHIFT (C) BYTE Wert=0x12
; KBDRSHIFT (C) BYTE Wert=0x59
; KBDENTER (C) BYTE Wert=0x5A
; KBDSPACE (C) BYTE Wert=0x29
; KBDBS (C) BYTE Wert=0x66
; KBDTAB (C) BYTE Wert=0x0D
; KBDESC (C) BYTE Wert=0x76
; KBDF1 (C) BYTE Wert=0x05
; KBDF2 (C) BYTE Wert=0x06
; KBDF3 (C) BYTE Wert=0x04
; KBDF4 (C) BYTE Wert=0x0C
; KBDF5 (C) BYTE Wert=0x03
; KBDF6 (C) BYTE Wert=0x0B
; KBDF7 (C) BYTE Wert=0x83
; KBDF8 (C) BYTE Wert=0x0A
; KBDF9 (C) BYTE Wert=0x01
; KBDF10 (C) BYTE Wert=0x09
; KBDF11 (C) BYTE Wert=0x78
; KBDF12 (C) BYTE Wert=0x07
; KBDRGUI (C) BYTE Wert=0x27
; KBDLGUI (C) BYTE Wert=0x1F
; KBDAPPS (C) BYTE Wert=0x2F
; KBDEND (C) BYTE Wert=0x69
; KBDHOME (C) BYTE Wert=0x6C
; KBDUP (C) BYTE Wert=0x75
; KBDDN (C) BYTE Wert=0x72
; KBDLEFT (C) BYTE Wert=0x6B
; KBDRIGHT (C) BYTE Wert=0x74
; KBDPGUP (C) BYTE Wert=0x7D
; KBDPGDN (C) BYTE Wert=0x7A
; KBDINSERT (C) BYTE Wert=0x70
; KBDDELETE (C) BYTE Wert=0x71
; KBDPRINT (C) BYTE Wert=0x12
; KBDPAUSE (C) BYTE Wert=0xE1
; SCANBREAK (C) BYTE Wert=0xF0
; SCANEXT (C) BYTE Wert=0xE0
; HSTSCROLL (C) BYTE Wert=0x00
; HSTPRINT (C) BYTE Wert=0x10
; HSTINS (C) BYTE Wert=0x16
; HSTHOME (C) BYTE Wert=0x00
; HSTPGUP (C) BYTE Wert=0x12
; HSTPGDN (C) BYTE Wert=0x03
; HSTDEL (C) BYTE Wert=0x08
; HSTEND (C) BYTE Wert=0x00
; HSTLEFT (C) BYTE Wert=0x13
; HSTRIGHT (C) BYTE Wert=0x04
; HSTUP (C) BYTE Wert=0x05
; HSTDN (C) BYTE Wert=0x18
; HSTRGUI (C) BYTE Wert=0x00
; HSTLGUI (C) BYTE Wert=0x00
; HSTAPPS (C) BYTE Wert=0x00
; HSTF1 (C) BYTE Wert=0x80
; HSTF2 (C) BYTE Wert=0x81
; HSTF3 (C) BYTE Wert=0x82
; HSTF4 (C) BYTE Wert=0x83
; HSTF5 (C) BYTE Wert=0x84
; HSTF6 (C) BYTE Wert=0x85
; HSTF7 (C) BYTE Wert=0x86
; HSTF8 (C) BYTE Wert=0x87
; HSTF9 (C) BYTE Wert=0x88
; HSTF10 (C) BYTE Wert=0x89
; HSTF11 (C) BYTE Wert=0x8A
; HSTF12 (C) BYTE Wert=0x8B
; SUMMER (B) BIT
; LED_GN (B) BIT
; LED_RT (B) BIT
; KEY_CLK_A (B) BIT
; KEY_CLK_E (B) BIT
; KEY_CLK_D (B) BIT
; KEY_DAT_A (B) BIT
; KEY_DAT_E (B) BIT
; KEY_DAT_D (B) BIT
; STEUER_STRING (V) STRING
; TEXT_STRING (V) STRING
; BITCNTR (V) BYTE
; KEYBSTATE (V) BYTE
; LEDSTATE (V) BYTE
; LOCALBYTE (V) BYTE
; KBSHIFTSTATE (V) BYTE
; TMPBYTE (V) BYTE
; CAPS_PRESSED (V) BOOLEAN
; NUM_PRESSED (V) BOOLEAN
; SCROLL_PRESSED (V) BOOLEAN
; DOCLICK (V) BOOLEAN
; INITFAILED (V) BOOLEAN
; LOCALMODE (V) BOOLEAN
; CH (V) CHAR
; SCANBUFFER (Y) BYTE
; SCANBUFFERPTR (V) WORD
; KEYBUFFER (Y) BYTE
; KEYBUFFERPTR (V) WORD
; SCAN_ZEICHEN (V) BYTE
; TASTATURLAYOUT_DE (V) BOOLEAN
; EEPROM_TEMP (V) BYTE
; WAITKON (C) WORD Wert=0x0012
; WAITKON2 (C) WORD Wert=0x032A
; BYTE_HEX_STRING (V) STRING
; BYTE_DEZ_STRING (V) STRING
; WORD_HEX_STRING (V) STRING
; DWORD_HEX_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; NEGATION_BYTE (F) 
; WAIT_MS (P) 
; BYTETOHEXSTRING (P) 
; BYTETODEZSTRING (P) 
; HEXSTRINGTOBYTE (F) 
; WORDTOHEXSTRING (P) 
; HEXSTRINGTOWORD (F) 
; DWORDTOHEXSTRING (P) 
; EEPROM_READ (F) 
; EEPROM_WRITE (P) 
; INITPORTS (P) 
; INIT_INT0 (P) 
; TON_SIRENE (P) 
; CLICK (P) 
; TON_A (P) 
; WRITE_SCAN (P) 
; READ_SCAN (F) 
; READ_KEY (F) 
; WRITE_KEY (P) 
; WRITE_C_KEY (P) 
; WRITE_TEXT (P) 
; SENDKEY (P) 
; SENDKEYCHAR (P) 
; INITKEYB (P) 
; SET_KBD_CLK (P) 
; RESET_KBD_CLK (P) 
; NOT_PARITY (F) 
; SENDTOKBD (P) 
; SET_KBD_STATE (P) 
; KBDRESET (P) 
; START_KEYBOARD (P) 
; SETZE_BIT_IN_KBSHIFTSTATE (P) 
; LOESCHE_BIT_IN_KBSHIFTSTATE (P) 
; SETZE_BIT_IN_LEDSTATE (P) 
; LOESCHE_BIT_IN_LEDSTATE (P) 
; SCAN_TO_KEY (P) 
; D0_A (B) BIT
; D1_A (B) BIT
; D2_A (B) BIT
; D3_A (B) BIT
; DR_A (B) BIT
; D0_D (B) BIT
; D1_D (B) BIT
; D2_D (B) BIT
; D3_D (B) BIT
; DR_D (B) BIT
; D0_E (B) BIT
; D1_E (B) BIT
; D2_E (B) BIT
; D3_E (B) BIT
; DR_E (B) BIT
; DS_A (B) BIT
; DS_D (B) BIT
; DS_E (B) BIT
; ITP3_WHO_AM_I (C) BYTE Wert=0x01
; ITP3_ERROR_CODE (C) BYTE Wert=0x02
; ITP3_CONOUT (C) BYTE Wert=0x03
; ITP3_CONST (C) BYTE Wert=0x04
; ITP3_CONIN (C) BYTE Wert=0x05
; ITP3_CLIENT_INIT (P) 
; ITP3_HALBBYTE_EINLESEN (F) 
; ITP3_BYTE_EINLESEN (F) 
; ITP3_HALBBYTE_AUSGEBEN (P) 
; ITP3_BYTE_AUSGEBEN (P) 
; ITP3_PRG_CONOUT (P) 
; ITP3_PRG_WHO_AM_I (P) 
; ITP3_PRG_CONST (P) 
; ITP3_PRG_CONIN (P) 
; ITP3_SERVER_ABFRAGE (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION NEGATION_BYTE (DAS_BYTE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOHEXSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; PROCEDURE BYTETODEZSTRING (WERT_BYTE : BYTE) (B1 : BYTE) (B2 : BYTE) (C1 : CHAR);
; FUNCTION HEXSTRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE WORDTOHEXSTRING (WERT_WORD : WORD) (BYTE_LOW : BYTE) (BYTE_HIGH : BYTE);
; FUNCTION HEXSTRINGTOWORD (C1 : CHAR) (S2W : WORD) (S2B : BYTE) (S2W2 : WORD) : WORD;
; PROCEDURE DWORDTOHEXSTRING (WERT_DWORD : DWORD) (WORD_LOW : WORD) (WORD_HIGH : WORD);
; FUNCTION EEPROM_READ (EE_ADRESSE : BYTE) (EE_DATEN : BYTE) : BYTE;
; PROCEDURE EEPROM_WRITE (EE_ADRESSE : BYTE) (EE_DATEN : BYTE);
; PROCEDURE INITPORTS;
; PROCEDURE INIT_INT0;
; PROCEDURE TON_SIRENE (DAUER : WORD) (FREQUENZ : WORD);
; PROCEDURE CLICK;
; PROCEDURE TON_A (FREQUENZ : WORD) (DAUER : WORD);
; PROCEDURE WRITE_SCAN (WRITE_SCAN_VALUE : BYTE);
; FUNCTION READ_SCAN (READ_SCAN_VALUE : BYTE) (SCAN_COUNTER : WORD) (B1 : BYTE) : BYTE;
; FUNCTION READ_KEY (READ_KEY_VALUE : BYTE) (KEY_COUNTER : WORD) (B1 : BYTE) : BYTE;
; PROCEDURE WRITE_KEY (WRITE_KEY_VALUE : BYTE);
; PROCEDURE WRITE_C_KEY (CKEY : CHAR) (B1 : BYTE);
; PROCEDURE WRITE_TEXT (ZAEHLER : BYTE) (C1 : CHAR);
; PROCEDURE SENDKEY (SKEY : BYTE) (C1 : CHAR) (B1 : BYTE);
; PROCEDURE SENDKEYCHAR (SKEY : CHAR) (B1 : BYTE);
; PROCEDURE INITKEYB;
; PROCEDURE SET_KBD_CLK;
; PROCEDURE RESET_KBD_CLK;
; FUNCTION NOT_PARITY (DAS_BYTE : BYTE) (ERGEBNIS : BOOLEAN) (B2 : BYTE) (B3 : BYTE) (B4 : BYTE) : BOOLEAN;
; PROCEDURE SENDTOKBD (B1 : BYTE) (P : BOOLEAN) (W : WORD) (CNT : BYTE) (REG : BYTE) (TEST : BYTE) (B2 : BYTE) (B3 : BYTE);
; PROCEDURE SET_KBD_STATE;
; PROCEDURE KBDRESET (WARTEN_AUF_TASTATUR : BOOLEAN);
; PROCEDURE START_KEYBOARD;
; PROCEDURE SETZE_BIT_IN_KBSHIFTSTATE (SHIFT_TASTE : BYTE);
; PROCEDURE LOESCHE_BIT_IN_KBSHIFTSTATE (SHIFT_TASTE : BYTE) (B1 : BYTE);
; PROCEDURE SETZE_BIT_IN_LEDSTATE (STATE_LED : BYTE);
; PROCEDURE LOESCHE_BIT_IN_LEDSTATE (STATE_LED : BYTE) (B1 : BYTE);
; PROCEDURE SCAN_TO_KEY (CURSCAN : BYTE) (B1 : BYTE) (CURSCAN_WORD : WORD);
; PROCEDURE ITP3_CLIENT_INIT;
; FUNCTION ITP3_HALBBYTE_EINLESEN (B1 : BYTE) : BYTE;
; FUNCTION ITP3_BYTE_EINLESEN (B1 : BYTE) (RESULT_BYTE : BYTE) : BYTE;
; PROCEDURE ITP3_HALBBYTE_AUSGEBEN (H_BYTE : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_BYTE_AUSGEBEN (H_BYTE : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_PRG_CONOUT (DATA_BYTE : BYTE);
; PROCEDURE ITP3_PRG_WHO_AM_I (DATA_BYTE : BYTE);
; PROCEDURE ITP3_PRG_CONST (DATA_BYTE : BYTE);
; PROCEDURE ITP3_PRG_CONIN (DATA_BYTE : BYTE);
; PROCEDURE ITP3_SERVER_ABFRAGE (CODE_BYTE : BYTE);
 
; *** Konstanten-ARRAYs ***
;
 
CODETAB_NORMAL_DE:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    '^',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'q'
.db    '1',0x00
.db    0x00,0x00
.db    'y','s'
.db    'a','w'
.db    '2',0x00
.db    0x00,'c'
.db    'x','d'
.db    'e','4'
.db    '3',0x00
.db    0x00,' '
.db    'v','f'
.db    't','r'
.db    '5',0x00
.db    0x00,'n'
.db    'b','h'
.db    'g','z'
.db    '6',0x00
.db    0x00,0x00
.db    'm','j'
.db    'u','7'
.db    '8',0x00
.db    0x00,','
.db    'k','i'
.db    'o','0'
.db    '9',0x00
.db    0x00,'.'
.db    '-','l'
.db    'o','p'
.db    0x5C,0x00
.db    0x00,0x00
.db    'a',0x00
.db    'u',0x27
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'+'
.db    0x00,'#'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_SHIFT_DE:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    '^',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'Q'
.db    '!',0x00
.db    0x00,0x00
.db    'Y','S'
.db    'A','W'
.db    '"',0x00
.db    0x00,'C'
.db    'X','D'
.db    'E','$'
.db    '#',0x00
.db    0x00,' '
.db    'V','F'
.db    'T','R'
.db    '%',0x00
.db    0x00,'N'
.db    'B','H'
.db    'G','Z'
.db    '&',0x00
.db    0x00,0x00
.db    'M','J'
.db    'U','/'
.db    '(',0x00
.db    0x00,';'
.db    'K','I'
.db    'O','='
.db    ')',0x00
.db    0x00,':'
.db    '_','L'
.db    'O','P'
.db    '?',0x00
.db    0x00,0x00
.db    'A',0x00
.db    'U',0x60
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'*'
.db    0x00,0x27
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_CTRL_DE:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    0x1E,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x11
.db    0x00,0x00
.db    0x00,0x00
.db    0x19,0x13
.db    0x01,0x17
.db    0x00,0x00
.db    0x00,0x03
.db    0x18,0x04
.db    0x05,0x00
.db    0x00,0x00
.db    0x00,' '
.db    0x16,0x06
.db    0x14,0x12
.db    0x00,0x00
.db    0x00,0x0E
.db    0x02,0x08
.db    0x07,0x1A
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,0x0A
.db    0x15,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x0B,0x09
.db    0x0F,0x00
.db    0x1D,0x00
.db    0x00,0x00
.db    0x00,0x0C
.db    0x0F,0x10
.db    0x1C,0x00
.db    0x00,0x00
.db    0x01,0x00
.db    0x15,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_ALT_DE:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'@'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x24,0x00
.db    '#',0x00
.db    0x00,' '
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'{'
.db    '[',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'}'
.db    ']',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x5C,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'~'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_NORMAL_EN:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    0x60,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'q'
.db    '1',0x00
.db    0x00,0x00
.db    'z','s'
.db    'a','w'
.db    '2',0x00
.db    0x00,'c'
.db    'x','d'
.db    'e','4'
.db    '3',0x00
.db    0x00,' '
.db    'v','f'
.db    't','r'
.db    '5',0x00
.db    0x00,'n'
.db    'b','h'
.db    'g','y'
.db    '6',0x00
.db    0x00,0x00
.db    'm','j'
.db    'u','7'
.db    '8',0x00
.db    0x00,','
.db    'k','i'
.db    'o','0'
.db    '9',0x00
.db    0x00,'.'
.db    '/','l'
.db    ';','p'
.db    '-',0x00
.db    0x00,0x00
.db    ',',0x00
.db    '[','='
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,']'
.db    0x00,0x5C
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_SHIFT_EN:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    '^',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'Q'
.db    '!',0x00
.db    0x00,0x00
.db    'Z','S'
.db    'A','W'
.db    '@',0x00
.db    0x00,'C'
.db    'X','D'
.db    'E','$'
.db    '#',0x00
.db    0x00,' '
.db    'V','F'
.db    'T','R'
.db    '%',0x00
.db    0x00,'N'
.db    'B','H'
.db    'G','Y'
.db    '^',0x00
.db    0x00,0x00
.db    'M','J'
.db    'U','&'
.db    '*',0x00
.db    0x00,'<'
.db    'K','I'
.db    'O',')'
.db    '(',0x00
.db    0x00,'>'
.db    '?','L'
.db    ':','P'
.db    '_',0x00
.db    0x00,0x00
.db    '"',0x00
.db    '{','+'
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'}'
.db    0x00,'|'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_CTRL_EN:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    0x1E,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x11
.db    0x00,0x00
.db    0x00,0x00
.db    0x1A,0x13
.db    0x01,0x17
.db    0x00,0x00
.db    0x00,0x03
.db    0x18,0x04
.db    0x05,0x00
.db    0x00,0x00
.db    0x00,' '
.db    0x16,0x06
.db    0x14,0x12
.db    0x00,0x00
.db    0x00,0x0E
.db    0x02,0x08
.db    0x07,0x19
.db    0x1E,0x00
.db    0x00,0x00
.db    0x0D,0x0A
.db    0x15,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x0B,0x09
.db    0x0F,0x00
.db    0x1D,0x00
.db    0x00,0x00
.db    0x00,0x0C
.db    0x0F,0x10
.db    0x1F,0x00
.db    0x00,0x00
.db    0x01,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,0x1D
.db    0x00,0x1C
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_ALT_EN:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'@'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x24,0x00
.db    '#',0x00
.db    0x00,' '
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'{'
.db    '[',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'}'
.db    ']',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x5C,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'~'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    3, "DIR"
 
M_CONST_STRING_1:
 .db    5, "POWER"
 
M_CONST_STRING_2:
 .db    4, "COPY "
 
M_CONST_STRING_3:
 .db    3, "ERA"
 
M_CONST_STRING_4:
 .db    5, "TYPEX"
 
M_CONST_STRING_5:
 .db    4, "EXIT "
 
M_CONST_STRING_6:
 .db    5, "TURBO"
 
M_CONST_STRING_7:
 .db    5, "TURBO"
 
M_CONST_STRING_8:
 .db    2, "DE "
 
M_CONST_STRING_9:
 .db    2, "EN "
 
M_CONST_STRING_10:
 .db    7, "EEPROM="
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=EI_INT0       Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=EI_INT1       Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=PCI0addr     ISR=PCINT0        Bemerkung=Pin Change Interrupt Request 0
; Nummer=5    ORG=PCI1addr     ISR=PCINT1        Bemerkung=Pin Change Interrupt Request 1
; Nummer=6    ORG=PCI2addr     ISR=PCINT2        Bemerkung=Pin Change Interrupt Request 2
; Nummer=7    ORG=WDTaddr      ISR=WDT           Bemerkung=Watchdog Time-out Interrupt
; Nummer=8    ORG=OC2Aaddr     ISR=TIMER2_COMPA  Bemerkung=Timer/Counter2 Compare Match A
; Nummer=9    ORG=OC2Baddr     ISR=TIMER2_COMPB  Bemerkung=Timer/Counter2 Compare Match B
; Nummer=10   ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=11   ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=12   ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=13   ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=14   ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=15   ORG=OC0Aaddr     ISR=TIMER0_COMPA  Bemerkung=Timer/Counter0 Compare Match A
; Nummer=16   ORG=OC0Baddr     ISR=TIMER0_COMPB  Bemerkung=Timer/Counter0 Compare Match B
; Nummer=17   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=18   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=19   ORG=URXCaddr     ISR=USART_RXC     Bemerkung=USART, Rx Complete
; Nummer=20   ORG=UDREaddr     ISR=USART_UDRE    Bemerkung=USART Data Register Empty
; Nummer=21   ORG=UTXCaddr     ISR=USART_TXC     Bemerkung=USART, Tx Complete
; Nummer=22   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=23   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=24   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=25   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=26   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
 
